﻿Imports System.IO
Imports System.Diagnostics
Imports System.Threading

Public Class Form1
    Dim ComServer, lBuildNo

    Public Sub KillApp()
        Try
            For Each prc As Process In Process.GetProcessesByName("SQLAcc")
                prc.Kill() 'Make sure no other SQLAcc is running
            Next
            Thread.Sleep(2000) 'Sleep for 2 seconds.
        Catch ex As Exception
            MsgBox(ex.Message, MsgBoxStyle.Exclamation)
        End Try
    End Sub

    Private Shared Function FormatAsRTF(ByVal DirtyText As String) As String
        Dim rtf As System.Windows.Forms.RichTextBox = New System.Windows.Forms.RichTextBox()
        rtf.Text = DirtyText
        Return rtf.Rtf
    End Function



    Public Sub CheckLogin(Optional ByVal AType As Integer = 0, Optional ByVal ATDCF As Integer = 0)
        Dim ADB, ADCF As String

        If edLogout.Checked Then
            KillApp()
        End If

        ComServer = CreateObject("SQLAcc.BizApp") 'Start run SQLAcc.exe

        ADB = If(AType = 0, edDB.Text.Trim, edDB2.Text.Trim)
        ADCF = If(ATDCF = 0, edDCF.Text.Trim, edDCF2.Text.Trim)

        If Not ComServer.IsLogin Then
            Try
                ComServer.Login(edUN.Text.Trim, edPW.Text.Trim, ADCF, ADB)
                ComServer.Minimize
            Catch ex As Exception
                MsgBox(ex.Message, MsgBoxStyle.Exclamation)
                ComServer = Nothing
            End Try
        End If
        If ComServer.IsLogin Then
            lBuildNo = ComServer.BuildNo
        End If
    End Sub

    Public Sub Logout()
        If edLogout.Checked Then
            ComServer.Logout
            FreeBiz(ComServer)
            'ComServer = Nothing 'End SQLAcc.exe which Auto Start only Once your App is Exit
        End If
    End Sub

    Public Sub FreeBiz(ByVal AbizObj As Object)
        System.Runtime.InteropServices.Marshal.ReleaseComObject(AbizObj)
    End Sub

    Public Function IsOdd(ByRef lngNumber As Long) As Boolean
        IsOdd = lngNumber And &H1
    End Function

    Public Function QuotedStr(ByRef str As String) As String
        QuotedStr = "'" + str.Replace("'", "''") + "'"
    End Function

    Private Sub BtnExport_Click(sender As Object, e As EventArgs) Handles btnExport.Click
        Dim BizObject, lMainDataSet, lDocKey As Object
        Dim strAgentCode, strDesc As String

        'Step 1: Create Com Server object
        CheckLogin()
        'Step 2: Find and Create the Biz Objects
        BizObject = ComServer.BizObjects.Find("Agent")

        'Step 3: Set Dataset
        lMainDataSet = BizObject.DataSets.Find("MainDataSet")
        strAgentCode = edCode.Text.Trim
        strDesc = edDesc.Text.Trim

        'Step 3: Insert or Update
        lDocKey = BizObject.FindKeyByRef("CODE", strAgentCode)
        Try
            Try
                If IsDBNull(lDocKey) Then
                    BizObject.[New]
                    lMainDataSet.FindField("CODE").value = strAgentCode
                    lMainDataSet.FindField("DESCRIPTION").value = strDesc
                Else 'Edit Data if found
                    BizObject.Params.Find("CODE").Value = lDocKey
                    BizObject.Open
                    BizObject.Edit
                    lMainDataSet.FindField("DESCRIPTION").value = strDesc
                End If
                'Step 4: Save & Close
                BizObject.Save
                MsgBox("Done", MsgBoxStyle.Information)
            Catch ex As Exception
                MsgBox(ex.Message, MsgBoxStyle.Exclamation)
            End Try
        Finally
            BizObject.close

            'Step 5 : Logout after done         
            FreeBiz(BizObject)
            Logout()
        End Try
    End Sub

    Private Sub BtnAging_Click(sender As Object, e As EventArgs) Handles btnAging.Click
        'M1 - Month to Date Payment received
        'M2 - Reserve field
        'C1 - Current Month
        'C2 - 1 Month
        'C3 - 2 Months 
        'C4 - 3 Months
        'C5 - 4 Months 
        'C6 - 5 Months & above

        Const Quote = """"
        Dim RptObject, lDataSet1, lDataSet2, lDateTo, lAgeData
        Dim tblC1, tblC2 As DataColumn
        Dim drt As DataRelation

        'Step 1: Create Com Server object
        CheckLogin()
        'Step 2: Find and Create the Report Objects
        RptObject = ComServer.RptObjects.Find("Customer.Aging.RO")
        'Step 3: Spool parameters
        lAgeData = "<?xml version=" & Quote & "1.0" & Quote & " standalone=" & Quote & "yes" & Quote & "?>  <DATAPACKET Version=" & Quote & "2.0" & Quote & "><METADATA><FIELDS>" &
       "<FIELD attrname=" & Quote & "ColumnNo" & Quote & " fieldtype=" & Quote & "i4" & Quote & " required=" & Quote & "true" & Quote & "/><FIELD attrname=" & Quote & "ColumnType" & Quote & " fieldtype=" & Quote & "string" & Quote & " WIDTH=" & Quote & "1" & Quote & "/>" &
       "<FIELD attrname=" & Quote & "Param1" & Quote & " fieldtype=" & Quote & "i4" & Quote & " required=" & Quote & "true" & Quote & "/><FIELD attrname=" & Quote & "Param2" & Quote & " fieldtype=" & Quote & "i4" & Quote & " required=" & Quote & "true" & Quote & "/>" &
       "<FIELD attrname=" & Quote & "IsLocal" & Quote & " fieldtype=" & Quote & "boolean" & Quote & "/><FIELD attrname=" & Quote & "HeaderScript" & Quote & " fieldtype=" & Quote & "bin.hex" & Quote & " SUBTYPE=" & Quote & "Text" & Quote & " WIDTH=" & Quote & "1" & Quote & "/>" &
       "</FIELDS><PARAMS/></METADATA><ROWDATA><ROW ColumnNo=" & Quote & "0" & Quote & " ColumnType=" & Quote & "" & Quote & " Param1=" & Quote & "0" & Quote & " Param2=" & Quote & "0" & Quote & " IsLocal=" & Quote & "FALSE" & Quote & "/>" &
       "<ROW ColumnNo=" & Quote & "1" & Quote & " ColumnType=" & Quote & "A" & Quote & " Param1=" & Quote & "0" & Quote & " Param2=" & Quote & "0" & Quote & " IsLocal=" & Quote & "FALSE" & Quote & " HeaderScript=" & Quote & "ObjectPascal&#013;begin&#013;Value:= &apos;Current Mth&apos;&#013;end;" & Quote & "/>" &
       "<ROW ColumnNo=" & Quote & "2" & Quote & " ColumnType=" & Quote & "A" & Quote & " Param1=" & Quote & "-1" & Quote & " Param2=" & Quote & "-1" & Quote & " IsLocal=" & Quote & "FALSE" & Quote & " HeaderScript=" & Quote & "ObjectPascal&#013;begin&#013;Value:= &apos;1 Months&apos;&#013;end;" & Quote & "/>" &
       "<ROW ColumnNo=" & Quote & "3" & Quote & " ColumnType=" & Quote & "A" & Quote & " Param1=" & Quote & "-2" & Quote & " Param2=" & Quote & "-2" & Quote & " IsLocal=" & Quote & "FALSE" & Quote & " HeaderScript=" & Quote & "ObjectPascal&#013;begin&#013;Value:= &apos;2 Months&apos;&#013;end;" & Quote & "/>" &
       "<ROW ColumnNo=" & Quote & "4" & Quote & " ColumnType=" & Quote & "A" & Quote & " Param1=" & Quote & "-3" & Quote & " Param2=" & Quote & "-3" & Quote & " IsLocal=" & Quote & "FALSE" & Quote & " HeaderScript=" & Quote & "ObjectPascal&#013;begin&#013;Value:= &apos;3 Months&apos;&#013;end;" & Quote & "/>" &
       "<ROW ColumnNo=" & Quote & "5" & Quote & " ColumnType=" & Quote & "A" & Quote & " Param1=" & Quote & "-4" & Quote & " Param2=" & Quote & "-4" & Quote & " IsLocal=" & Quote & "FALSE" & Quote & " HeaderScript=" & Quote & "ObjectPascal&#013;begin&#013;Value:= &apos;4 Months&apos;&#013;end;" & Quote & "/>" &
       "<ROW ColumnNo=" & Quote & "6" & Quote & " ColumnType=" & Quote & "B" & Quote & " Param1=" & Quote & "-999999" & Quote & " Param2=" & Quote & "-5" & Quote & " IsLocal=" & Quote & "FALSE" & Quote & " HeaderScript=" & Quote & "ObjectPascal&#013;begin&#013;Value:= &apos;5 Month &amp; above&apos;&#013;end;" & Quote & "/>" &
       "</ROWDATA></DATAPACKET>"

        RptObject.Params.Find("ActualGroupBy").Value = "Code;CompanyName" 'Fixed
        '  RptObject.Params.Find("AgentData").Value            =  'Not use if AllAgent is True
        RptObject.Params.Find("AgingData").Value = lAgeData 'Fixed

        lDateTo = CDate("April 17, 2019")
        RptObject.Params.Find("AgingDate").Value = lDateTo

        RptObject.Params.Find("AgingOn").Value = "I" 'Fixed
        RptObject.Params.Find("AllAgent").Value = True
        RptObject.Params.Find("AllArea").Value = True
        RptObject.Params.Find("AllCompany").Value = True
        RptObject.Params.Find("AllCompanyCategory").Value = True
        RptObject.Params.Find("AllControlAccount").Value = True
        RptObject.Params.Find("AllCurrency").Value = True
        RptObject.Params.Find("AllDocProject").Value = True
        '  RptObject.Params.Find("AreaData").Value             =  'Not use if AllArea is True
        '  RptObject.Params.Find("CompanyCategoryData").Value  =  'Not use if AllCompanyCategory is True
        'RptObject.Params.Find("CompanyData").Value = "300-A0001" & vbCrLf & "300-C0001" 'Filter by Customer Code 300-A0001 & 300-C0001
        '  RptObject.Params.Find("ControlAccountData").Value   =  'Not use if AllControlAccount is True
        '  RptObject.Params.Find("CurrencyData").Value         =  'Not use if AllCurrency is True
        '  RptObject.Params.Find("DocProjectData").Value       =  'Not use if AllDocProject is True
        RptObject.Params.Find("FilterPostDate").Value = False
        '  RptObject.Params.Find("GroupBy").Value               = 'Not use 
        RptObject.Params.Find("IncludePDC").Value = False
        RptObject.Params.Find("IncludeZeroBalance").Value = False
        RptObject.Params.Find("SortBy").Value = "Code;CompanyName"
        RptObject.Params.Find("DateTo").Value = lDateTo

        'Step 4: Perform Report calculation 
        RptObject.CalculateReport()
        lDataSet1 = RptObject.DataSets.Find("cdsMain")
        lDataSet2 = RptObject.DataSets.Find("cdsDocument")
        MsgBox("Count - Main " & lDataSet1.RecordCount, MsgBoxStyle.Information)
        MsgBox("Count - Document " & lDataSet2.RecordCount, MsgBoxStyle.Information)

        'Step 5 : Convert to Dataset
        ClearTables()

        PrepareData(lDataSet1, "Master")
        PrepareData(lDataSet2, "Detail")

        'Step 6 : Get Relation column
        tblC1 = Tbl.Tables("Master").Columns("Code")
        tblC2 = Tbl.Tables("Detail").Columns("Code")
        drt = New DataRelation("relation", tblC1, tblC2)


        'Step 7 : Set Grid Info
        SetGridInfo(drt)

        MsgBox("Done", MsgBoxStyle.Information)

        'Step 8 : Logout after done 
        Logout()
        RptObject = Nothing
    End Sub

    Private Sub BtnSLCSEdit_Click(sender As Object, e As EventArgs) Handles btnSLCSEdit.Click
        Dim lSQL, lDataSet, BizObject, lMain, lDetail

        'Step 1: Create Com Server object
        CheckLogin()

        'Step 2: GetDockey
        lSQL = "SELECT Dockey FROM SL_CS "
        lSQL = lSQL & "WHERE DocNo=" & QuotedStr(edDocNo.Text)  'CS-00002
        lSQL = lSQL & " AND Code='300-K0001' "
        lDataSet = ComServer.DBManager.NewDataSet(lSQL)

        'Step 3: Find and Create the Biz Objects
        BizObject = ComServer.BizObjects.Find("SL_CS")

        'Step 4: Set Dataset
        lMain = BizObject.DataSets.Find("MainDataSet")  'lMain contains master data
        lDetail = BizObject.DataSets.Find("cdsDocDetail") 'lDetail contains detail data  

        'Step 5 : Find Doc Number
        If lDataSet.RecordCount > 0 Then
            lDataSet.First
            BizObject.Params.Find("DocKey").Value = lDataSet.FindField("DocKey").AsString

            BizObject.Open
            BizObject.Edit
            lMain.Edit
            lMain.FindField("Description").AsString = "Edited Description 123"

            'Step 6: Delete all Detail
            While lDetail.RecordCount <> 0
                lDetail.First
                lDetail.Delete
            End While

            'Step 7: Append Detail
            lDetail.Append
            lDetail.FindField("DtlKey").value = -1
            lDetail.FindField("Account").value = "500-0000"
            lDetail.FindField("Description").value = "Item A"
            lDetail.FindField("Tax").value = ""
            lDetail.FindField("TaxInclusive").value = 0
            lDetail.FindField("Amount").value = 410.37
            lDetail.FindField("TaxAmt").value = 0
            lDetail.Post

            'Step 8: Save Document
            BizObject.Save
            BizObject.Close

            MsgBox("Done", MsgBoxStyle.Information)
        Else
            MsgBox("Record Not Found", MsgBoxStyle.Exclamation)
        End If
        'Step 9 : Logout after done  
        FreeBiz(BizObject)
        FreeBiz(lDataSet)
        Logout()
    End Sub

    Private Sub BtnGLJEEdit_Click(sender As Object, e As EventArgs) Handles btnGLJEEdit.Click
        Dim lSQL, lDataSet, BizObject, lMain, lDetail

        'Step 1: Create Com Server object
        CheckLogin()

        'Step 2: GetDockey
        lSQL = "SELECT Dockey FROM GL_JE "
        lSQL = lSQL & "WHERE DocNo=" & QuotedStr(edDocNo.Text) 'JV-00002
        lDataSet = ComServer.DBManager.NewDataSet(lSQL)

        'Step 3: Find and Create the Biz Objects
        BizObject = ComServer.BizObjects.Find("GL_JE")

        'Step 4: Set Dataset
        lMain = BizObject.DataSets.Find("MainDataSet")  'lMain contains master data
        lDetail = BizObject.DataSets.Find("cdsDocDetail") 'lDetail contains detail data  

        'Step 5 : Find Doc Number
        If lDataSet.RecordCount > 0 Then
            lDataSet.First
            BizObject.Params.Find("DocKey").Value = lDataSet.FindField("DocKey").AsString

            BizObject.Open
            BizObject.Edit
            lMain.Edit
            lMain.FindField("Description").AsString = "Edited Description 123"

            'Step 6: Delete all Detail
            While lDetail.RecordCount <> 0
                lDetail.First
                lDetail.Delete
            End While

            'Step 7: Append Detail
            lDetail.Append
            lDetail.FindField("DtlKey").value = -1
            lDetail.FindField("Code").value = edCode.Text
            lDetail.FindField("Description").value = "testing desc1"
            lDetail.FindField("Project").value = "P12W1"
            lDetail.FindField("Tax").value = ""
            lDetail.FindField("TaxInclusive").value = 0
            lDetail.FindField("LocalDR").value = 200
            lDetail.FindField("DR").value = 200
            lDetail.Post

            lDetail.Append
            lDetail.FindField("DtlKey").value = -1
            lDetail.FindField("Code").value = edCode.Text
            lDetail.FindField("Description").value = "testing desc2"
            lDetail.FindField("Project").value = "P13W1"
            lDetail.FindField("Tax").value = ""
            lDetail.FindField("TaxInclusive").value = 0
            lDetail.FindField("LocalCR").value = 200
            lDetail.FindField("CR").value = 200
            lDetail.Post

            lDetail.Append
            lDetail.FindField("DtlKey").value = -1
            lDetail.FindField("Code").value = edCode.Text
            lDetail.FindField("Description").value = "testing desc3"
            lDetail.FindField("Project").value = "P12W1"
            lDetail.FindField("Tax").value = ""
            lDetail.FindField("TaxInclusive").value = 0
            lDetail.FindField("LocalDR").value = 500.1
            lDetail.FindField("DR").value = 500.1
            lDetail.Post

            lDetail.Append
            lDetail.FindField("DtlKey").value = -1
            lDetail.FindField("Code").value = edCode.Text
            lDetail.FindField("Description").value = "testing desc4"
            lDetail.FindField("Project").value = "P13W1"
            lDetail.FindField("Tax").value = ""
            lDetail.FindField("TaxInclusive").value = 0
            lDetail.FindField("LocalCR").value = 500.1
            lDetail.FindField("CR").value = 500.1
            lDetail.Post

            'Step 8: Save Document
            BizObject.Save
            BizObject.Close

            MsgBox("Done", MsgBoxStyle.Information)
        Else
            MsgBox("Record Not Found", MsgBoxStyle.Exclamation)
        End If
        'Step 9 : Logout after done  
        FreeBiz(BizObject)
        FreeBiz(lDataSet)
        Logout()
    End Sub

    Private Sub BtnNextNo_Click(sender As Object, e As EventArgs) Handles btnNextNo.Click
        Dim lSQL, lDataSet, lNextNo, lDate
        lDate = DateTime.Today

        'Step 1: Create Com Server object
        CheckLogin()

        'Step 2: Get DocNo
        lSQL = "SELECT A.*, B.NEXTNUMBER FROM SY_DOCNO A "
        lSQL = lSQL & "INNER JOIN SY_DOCNO_DTL B ON (A.DOCKEY=B.PARENTKEY) "
        lSQL = lSQL & "WHERE A.DOCTYPE='IV' "
        lSQL = lSQL & "AND A.DESCRIPTION='Customer Invoice' "
        lSQL = lSQL & "AND A.STATESET=1 "

        lDataSet = ComServer.DBManager.NewDataSet(lSQL)

        If lDataSet.RecordCount > 0 Then
            lDataSet.First
            edDesc.Text = lDataSet.FindField("Description").AsString
            edCode.Text = lDataSet.FindField("Format").AsString
            lNextNo = lDataSet.FindField("NextNumber").Value

            If (edCode.Text.Contains("{") = True) Then 'Convert from eg IV-{@YYMM}-%.5d to IV-202102-{0:d5}
                If (edCode.Text.Contains("YYYY") = True) Then
                    edCode.Text = edCode.Text.Replace("YYYY", Format(lDate, "yyyy"))
                End If
                If (edCode.Text.Contains("YY") = True) Then
                    edCode.Text = edCode.Text.Replace("YY", Format(lDate, "yy"))
                End If
                If (edCode.Text.Contains("MM") = True) Then
                    edCode.Text = edCode.Text.Replace("MM", Format(lDate, "MM"))
                End If
                edCode.Text = edCode.Text.Replace("@", "")
                edCode.Text = edCode.Text.Replace("{", "")
                edCode.Text = edCode.Text.Replace("}", "")
            End If

            'Convert from eg IV-%.5d to IV-{0:d5}
            edCode.Text = edCode.Text.Replace("d", "")
            edCode.Text = edCode.Text.Replace("%.", "{0:d") + "}"
            edDocNo.Text = String.Format(edCode.Text, lNextNo)
        Else
            MsgBox("Record Not Found", MsgBoxStyle.Exclamation)
        End If
        FreeBiz(lDataSet)
        Logout()
    End Sub

    Private Sub EdDCF_DoubleClick(sender As Object, e As EventArgs) Handles edDCF.DoubleClick
        Dim fd As OpenFileDialog = New OpenFileDialog With {
            .Title = "Open DCF File...",
            .InitialDirectory = My.Computer.FileSystem.SpecialDirectories.Desktop,
            .Filter = "DCF File (*.DCF)|*.DCF|All Files (*.*)|*.*",
            .FilterIndex = 1,
            .RestoreDirectory = True
        }

        If fd.ShowDialog() = DialogResult.OK Then
            edDCF.Text = fd.FileName
        End If
    End Sub

    Private Sub EdDCF2_DoubleClick(sender As Object, e As EventArgs) Handles edDCF2.DoubleClick
        Dim fd As OpenFileDialog = New OpenFileDialog With {
            .Title = "Open DCF File...",
            .InitialDirectory = My.Computer.FileSystem.SpecialDirectories.Desktop,
            .Filter = "DCF File (*.DCF)|*.DCF|All Files (*.*)|*.*",
            .FilterIndex = 1,
            .RestoreDirectory = True
        }

        If fd.ShowDialog() = DialogResult.OK Then
            edDCF2.Text = fd.FileName
        End If
    End Sub

    Private Sub EdDB_DoubleClick(sender As Object, e As EventArgs) Handles edDB.DoubleClick
        Dim fd As OpenFileDialog = New OpenFileDialog With {
            .Title = "Open Firebird File...",
            .InitialDirectory = My.Computer.FileSystem.SpecialDirectories.Desktop,
            .Filter = "Firebird File (*.FDB)|*.FDB|All Files (*.*)|*.*",
            .FilterIndex = 1,
            .RestoreDirectory = True
        }

        If fd.ShowDialog() = DialogResult.OK Then
            edDB.Text = IO.Path.GetFileName(fd.FileName)
        End If
    End Sub

    Private Sub EdDB2_MouseDoubleClick(sender As Object, e As MouseEventArgs) Handles edDB2.MouseDoubleClick
        Dim fd As OpenFileDialog = New OpenFileDialog With {
            .Title = "Open Firebird File...",
            .InitialDirectory = My.Computer.FileSystem.SpecialDirectories.Desktop,
            .Filter = "Firebird File (*.FDB)|*.FDB|All Files (*.*)|*.*",
            .FilterIndex = 1,
            .RestoreDirectory = True
        }

        If fd.ShowDialog() = DialogResult.OK Then
            edDB2.Text = IO.Path.GetFileName(fd.FileName)
        End If
    End Sub

    Private Sub BtnPost2_Click(sender As Object, e As EventArgs) Handles btnPost2.Click
        Dim lMain, lDtl, BizObject, lQty,
            lFld_MDockey, lFld_DocNo, lFld_Code, lFld_DocDate, lFld_PostDate, lFld_TaxDate,
            lFld_Desc, lFld_Cancelled,
            lFld_DDockey, lFld_DtlKey, lFld_Seq, lFld_ItemCode, lFld_Acc, lFld_Qty, lFld_Tax,
            lFld_TaxRate, lFld_TaxInc, lFld_UnitPrice, lFld_TaxAmt

        Dim I, J, R As Integer
        Dim lDate As New Date(Date.Now.Year, 1, 1)
        Dim IP As Random

        edLogout.Checked = True

        For I = 1 To edRecord.Value
            If IsOdd(I) Then
                CheckLogin(0)
            Else
                CheckLogin(1)
            End If


            BizObject = ComServer.BizObjects.Find("SL_CS")
            lMain = BizObject.DataSets.Find("MainDataSet")  'lMain contains master data
            lDtl = BizObject.DataSets.Find("cdsDocDetail") 'lDetail contains detail data

            lFld_MDockey = lMain.FindField("DOCKEY")
            lFld_DocNo = lMain.FindField("DocNo")
            lFld_Code = lMain.FindField("CODE")
            lFld_DocDate = lMain.FindField("DocDate")
            lFld_PostDate = lMain.FindField("PostDate")
            lFld_TaxDate = lMain.FindField("TAXDATE")
            lFld_Desc = lMain.FindField("Description")
            lFld_Cancelled = lMain.FindField("Cancelled")

            lFld_DDockey = lDtl.FindField("DOCKEY")
            lFld_DtlKey = lDtl.FindField("DTLKEY")
            lFld_Seq = lDtl.FindField("SEQ")
            lFld_ItemCode = lDtl.FindField("ItemCode")
            lFld_Acc = lDtl.FindField("Account")
            lFld_Qty = lDtl.FindField("QTY")
            lFld_Tax = lDtl.FindField("TAX")
            lFld_TaxRate = lDtl.FindField("TAXRATE")
            lFld_TaxInc = lDtl.FindField("TAXINCLUSIVE")
            lFld_UnitPrice = lDtl.FindField("UNITPRICE")
            lFld_TaxAmt = lDtl.FindField("TaxAmt")


            lbTime.Text = "Posting Record No : " & I
            BizObject.[New]
            'Begin Append Master
            lFld_MDockey.Value = -1
            lFld_DocNo.AsString = String.Format(edFmt.Text, I)

            IP = New Random
            R = IP.Next(0, edCoCode.Lines.Count)
            lFld_Code.AsString = edCoCode.Lines.GetValue(R)

            If I >= 10 Then
                lDate = lDate.AddDays(I / 10)
            End If
            lFld_DocDate.Value = lDate
            lFld_PostDate.Value = lDate
            lFld_TaxDate.Value = lDate
            lFld_Desc.AsString = "Sales"
            lFld_Cancelled.Value = "F"
            lMain.Post

            'Begin Append Detail
            For J = 1 To edRecordItem.Value
                lDtl.Append
                lFld_DtlKey.Value = -1
                lFld_DDockey.Value = -1
                lFld_Seq.Value = J

                IP = New Random
                R = IP.Next(0, edItem.Lines.Count)
                lFld_ItemCode.AsString = edItem.Lines.GetValue(R)

                IP = New Random
                lQty = IP.Next(1, 10)

                'lFld_Acc.AsString = "500-000" 'Sales Account Code  & can ignore if had itemcode
                lFld_Qty.AsFloat = lQty

                If edWithTax.Checked Then
                    lFld_Tax.AsString = "SR"
                    lFld_TaxRate.AsString = "6%"
                    lFld_TaxInc.Value = 0
                Else
                    lFld_Tax.AsString = ""
                    lFld_TaxRate.AsString = ""
                    lFld_TaxInc.Value = 0
                End If

                lFld_UnitPrice.AsFloat = 100
                If edWithTax.Checked Then
                    lFld_TaxAmt.AsFloat = 0.06 * (lQty * 100) 'TaxRate * (Qty * UnitPrice Excluding Tax)
                Else
                    lFld_TaxAmt.AsFloat = 0
                End If
                lDtl.Post
            Next
            BizObject.Save
            BizObject.Close
            FreeBiz(BizObject)
        Next
        MsgBox("Done", MsgBoxStyle.Information)
        Logout()
    End Sub

    Private Sub BtnPost1_Click(sender As Object, e As EventArgs) Handles btnPost1.Click
        Dim lMain, lDtl, BizObject, lQty,
            lFld_MDockey, lFld_DocNo, lFld_Code, lFld_DocDate, lFld_PostDate, lFld_TaxDate,
            lFld_Desc, lFld_Cancelled,
            lFld_DDockey, lFld_DtlKey, lFld_Seq, lFld_ItemCode, lFld_Acc, lFld_Qty, lFld_Tax,
            lFld_TaxRate, lFld_TaxInc, lFld_UnitPrice, lFld_TaxAmt

        Dim I, J, R As Integer
        Dim lDate As New Date(Date.Now.Year, 1, 1)
        Dim IP As Random
        Dim lDocNo As String

        For I = 1 To edRecord.Value
            If I = 1 Then
                CheckLogin(0)
            End If
            BizObject = ComServer.BizObjects.Find(edBizType.Text.Trim)
            lMain = BizObject.DataSets.Find("MainDataSet")  'lMain contains master data
            lDtl = BizObject.DataSets.Find("cdsDocDetail") 'lDetail contains detail data

            lFld_MDockey = lMain.FindField("DOCKEY")
            lFld_DocNo = lMain.FindField("DocNo")
            lFld_Code = lMain.FindField("CODE")
            lFld_DocDate = lMain.FindField("DocDate")
            lFld_PostDate = lMain.FindField("PostDate")
            lFld_TaxDate = lMain.FindField("TAXDATE")
            lFld_Desc = lMain.FindField("Description")
            lFld_Cancelled = lMain.FindField("Cancelled")

            lFld_DDockey = lDtl.FindField("DOCKEY")
            lFld_DtlKey = lDtl.FindField("DTLKEY")
            lFld_Seq = lDtl.FindField("SEQ")
            lFld_ItemCode = lDtl.FindField("ItemCode")
            lFld_Acc = lDtl.FindField("Account")
            lFld_Qty = lDtl.FindField("QTY")
            lFld_Tax = lDtl.FindField("TAX")
            lFld_TaxRate = lDtl.FindField("TAXRATE")
            lFld_TaxInc = lDtl.FindField("TAXINCLUSIVE")
            lFld_UnitPrice = lDtl.FindField("UNITPRICE")
            lFld_TaxAmt = lDtl.FindField("TaxAmt")
            'End If

            lbTime.Text = "Posting Record No : " & I
            BizObject.[New]
            'Begin Append Master
            lFld_MDockey.Value = -1
            lDocNo = String.Format(edFmt.Text, I)
            lFld_DocNo.AsString = lDocNo

            IP = New Random
            R = IP.Next(0, edCoCode.Lines.Count)
            lFld_Code.AsString = "300-C0001" 'edCoCode.Lines.GetValue(R)

            If I >= 10 Then
                lDate = lDate.AddDays(I / 10)
            End If
            lFld_DocDate.Value = lDate
            lFld_PostDate.Value = lDate
            lFld_TaxDate.Value = lDate
            lFld_Desc.AsString = "Sales"
            lFld_Cancelled.Value = "F"
            lMain.Post

            'Begin Append Detail
            For J = 1 To edRecordItem.Value
                lDtl.Append
                lFld_DtlKey.Value = -1
                lFld_DDockey.Value = -1
                lFld_Seq.Value = J

                IP = New Random
                R = IP.Next(0, edItem.Lines.Count)
                lFld_ItemCode.AsString = edItem.Lines.GetValue(R)

                IP = New Random
                lQty = IP.Next(1, 10)

                'lFld_Acc.AsString = "500-000" 'Sales Account Code  & can ignore if had itemcode
                lFld_Qty.AsFloat = lQty

                If edWithTax.Checked Then
                    lFld_Tax.AsString = "SR"
                    lFld_TaxRate.AsString = "6%"
                    lFld_TaxInc.Value = 0
                Else
                    lFld_Tax.AsString = ""
                    lFld_TaxRate.AsString = ""
                    lFld_TaxInc.Value = 0
                End If

                lFld_UnitPrice.AsFloat = 100
                If edWithTax.Checked Then
                    lFld_TaxAmt.AsFloat = 0.06 * (lQty * 100) 'TaxRate * (Qty * UnitPrice Excluding Tax)
                Else
                    lFld_TaxAmt.AsFloat = 0
                End If
                lDtl.Post
            Next
            BizObject.Save
            BizObject.Close
            FreeBiz(BizObject)
            Application.DoEvents()
            lbTime.Text = "Posting Payment..."
            Call InsertARPM(lDocNo, lDate)
            Application.DoEvents()
        Next
        MsgBox("Done", MsgBoxStyle.Information)
        FreeBiz(BizObject)
        Logout()
    End Sub

    Private Sub BtnSTAS_Click(sender As Object, e As EventArgs) Handles BtnSTAS.Click
        Dim lDate, lMain, lDtl, BizObject,
            lFld_MDockey, lFld_DocNo, lFld_Code, lFld_DocDate, lFld_PostDate, lFld_MLoc,
            lFld_Desc, lFld_Cancelled, lFld_MQty, lFld_MUOM,
            lFld_DDockey, lFld_DtlKey, lFld_Seq, lFld_ItemCode, lFld_Qty,
            lFld_Wastage

        CheckLogin(0)

        BizObject = ComServer.BizObjects.Find("ST_AS")
        lMain = BizObject.DataSets.Find("MainDataSet")  'lMain contains master data
        lDtl = BizObject.DataSets.Find("cdsDocDetail") 'lDetail contains detail data

        lFld_MDockey = lMain.FindField("DOCKEY")
        lFld_DocNo = lMain.FindField("DocNo")
        lFld_Code = lMain.FindField("ITEMCODE")
        lFld_DocDate = lMain.FindField("DocDate")
        lFld_PostDate = lMain.FindField("PostDate")
        lFld_Desc = lMain.FindField("Description")
        lFld_Cancelled = lMain.FindField("Cancelled")
        lFld_MLoc = lMain.FindField("LOCATION")
        lFld_MQty = lMain.FindField("QTY")
        lFld_MUOM = lMain.FindField("UOM")

        lFld_DDockey = lDtl.FindField("DOCKEY")
        lFld_DtlKey = lDtl.FindField("DTLKEY")
        lFld_Seq = lDtl.FindField("SEQ")
        lFld_ItemCode = lDtl.FindField("ItemCode")
        lFld_Qty = lDtl.FindField("QTY")
        lFld_Wastage = lDtl.FindField("ISWASTAGE")


        lDate = CDate("January 1, 2019")

        BizObject.[New]
        'Begin Append Master
        lFld_MDockey.Value = -1
        lFld_DocNo.AsString = "--AS Test--"
        lFld_Code.AsString = "BOM"
        lFld_DocDate.Value = lDate
        lFld_PostDate.Value = lDate
        lFld_Desc.AsString = "BOM Description 123"
        lFld_Cancelled.AsString = "F"
        lFld_MLoc.AsString = "KL"
        lFld_MQty.AsFloat = 2
        lFld_MUOM.AsString = "UNIT"

        'Delete all Detail
        While lDtl.RecordCount <> 0
            lDtl.First
            lDtl.Delete
        End While

        lDtl.Append
        lFld_DtlKey.Value = -1
        lFld_DDockey.Value = -1
        lFld_Seq.Value = 1
        lFld_ItemCode.AsString = "ANT"
        lFld_Qty.AsFloat = 3
        lFld_Wastage.AsString = "F"
        lDtl.Post

        lDtl.Append
        lFld_DtlKey.Value = -1
        lFld_DDockey.Value = -1
        lFld_Seq.Value = 2
        lFld_ItemCode.AsString = "ANT"
        lFld_Qty.AsFloat = 2
        lFld_Wastage.AsString = "T"
        lDtl.Post

        lDtl.Append
        lFld_DtlKey.Value = -1
        lFld_DDockey.Value = -1
        lFld_Seq.Value = 3
        lFld_ItemCode.AsString = "COVER"
        lFld_Qty.AsFloat = 3
        lFld_Wastage.AsString = "F"
        lDtl.Post

        BizObject.Save
        BizObject.Close
        MsgBox("Done", MsgBoxStyle.Information)
        FreeBiz(BizObject)
        Logout()
    End Sub

    Private Sub BtnJO2AS_Click(sender As Object, e As EventArgs) Handles btnJO2AS.Click
        Dim lDate, lMain, lDtl, BizObject, lxFer, lSQL,
            lFld_MDockey, lFld_DocNo, lFld_Code, lFld_DocDate, lFld_PostDate, lFld_MLoc,
            lFld_Desc, lFld_Cancelled, lFld_MQty, lFld_MUOM, lFld_MItemCode, lFld_FromDocType, lFld_FromDockey,
            lFld_DDockey, lFld_DtlKey, lFld_Seq, lFld_ItemCode, lFld_Qty,
            lFld_Wastage

        CheckLogin(0)
        'Insert PD JO
        BizObject = ComServer.BizObjects.Find("PD_JO")
        lMain = BizObject.DataSets.Find("MainDataSet")  'lMain contains master data
        lDtl = BizObject.DataSets.Find("cdsDocDetail") 'lDetail contains detail data

        lFld_MDockey = lMain.FindField("DOCKEY")
        lFld_DocNo = lMain.FindField("DocNo")
        lFld_Code = lMain.FindField("CODE")
        lFld_MItemCode = lMain.FindField("ITEMCODE")
        lFld_DocDate = lMain.FindField("DocDate")
        lFld_PostDate = lMain.FindField("PostDate")
        lFld_Desc = lMain.FindField("Description")
        lFld_Cancelled = lMain.FindField("Cancelled")
        lFld_MLoc = lMain.FindField("LOCATION")
        lFld_MQty = lMain.FindField("QTY")
        lFld_MUOM = lMain.FindField("UOM")

        lFld_DDockey = lDtl.FindField("DOCKEY")
        lFld_DtlKey = lDtl.FindField("DTLKEY")
        lFld_Seq = lDtl.FindField("SEQ")
        lFld_ItemCode = lDtl.FindField("ItemCode")
        lFld_Qty = lDtl.FindField("QTY")
        lFld_Wastage = lDtl.FindField("ISWASTAGE")

        lDate = CDate("January 2, 2019")

        lbTime.Text = "Posting Job Order..."
        BizObject.[New]
        'Begin Append Master
        lFld_MDockey.Value = -1
        lFld_DocNo.AsString = "--JO Test--"
        lFld_Code.AsString = "300-A0003"
        lFld_MItemCode.AsString = "BOM"
        lFld_DocDate.Value = lDate
        lFld_PostDate.Value = lDate
        lFld_Desc.AsString = "BOM Description JO"
        lFld_Cancelled.AsString = "F"
        lFld_MLoc.AsString = "KL"
        lFld_MQty.AsFloat = 2
        lFld_MUOM.AsString = "UNIT"

        BizObject.Save
        BizObject.Close

        'Check Is Transfered or not
        lbTime.Text = "Check Transfer Status..."
        lSQL = "SELECT DocKey FROM ST_AS "
        lSQL = lSQL & "WHERE FromDocKey IN (SELECT DocKey FROM PD_JO "
        lSQL = lSQL & "WHERE DocNo='--JO Test--') "
        lSQL = lSQL & "AND FromDocType='JO' "
        lxFer = ComServer.DBManager.NewDataSet(lSQL)

        If lxFer.RecordCount = 0 Then
            lSQL = "SELECT DocKey FROM PD_JO "
            lSQL = lSQL & "WHERE DocNo='--JO Test--' "
            lxFer = ComServer.DBManager.NewDataSet(lSQL)

            'Post ST AS
            BizObject = ComServer.BizObjects.Find("ST_AS")
            lMain = BizObject.DataSets.Find("MainDataSet")  'lMain contains master data
            lDtl = BizObject.DataSets.Find("cdsDocDetail") 'lDetail contains detail data

            lFld_MDockey = lMain.FindField("DOCKEY")
            lFld_DocNo = lMain.FindField("DocNo")
            lFld_MItemCode = lMain.FindField("ITEMCODE")
            lFld_DocDate = lMain.FindField("DocDate")
            lFld_PostDate = lMain.FindField("PostDate")
            lFld_Desc = lMain.FindField("Description")
            lFld_Cancelled = lMain.FindField("Cancelled")
            lFld_MLoc = lMain.FindField("LOCATION")
            lFld_MQty = lMain.FindField("QTY")
            lFld_MUOM = lMain.FindField("UOM")
            lFld_FromDocType = lMain.FindField("FromDocType")
            lFld_FromDockey = lMain.FindField("FromDocKey")

            lFld_DDockey = lDtl.FindField("DOCKEY")
            lFld_DtlKey = lDtl.FindField("DTLKEY")
            lFld_Seq = lDtl.FindField("SEQ")
            lFld_ItemCode = lDtl.FindField("ItemCode")
            lFld_Qty = lDtl.FindField("QTY")
            lFld_Wastage = lDtl.FindField("ISWASTAGE")

            lDate = CDate("January 1, 2019")

            lbTime.Text = "Transfer JO to AS..."
            BizObject.[New]
            'Begin Append Master
            lFld_MDockey.Value = -1
            lFld_DocNo.AsString = "--AS Test--"
            lFld_MItemCode.AsString = "BOM"
            lFld_DocDate.Value = lDate
            lFld_PostDate.Value = lDate
            lFld_Desc.AsString = "BOM Description AS"
            lFld_Cancelled.AsString = "F"
            lFld_MLoc.AsString = "KL"
            lFld_MQty.AsFloat = 2
            lFld_MUOM.AsString = "UNIT"
            lFld_FromDocType.AsString = "JO"
            lFld_FromDockey.AsFloat = lxFer.FindField("DocKey").AsFloat

            'Delete all Detail
            While lDtl.RecordCount <> 0
                lDtl.First
                lDtl.Delete
            End While

            lDtl.Append
            lFld_DtlKey.Value = -1
            lFld_DDockey.Value = -1
            lFld_Seq.Value = 1
            lFld_ItemCode.AsString = "ANT"
            lFld_Qty.AsFloat = 3
            lFld_Wastage.AsString = "F"
            lDtl.Post

            lDtl.Append
            lFld_DtlKey.Value = -1
            lFld_DDockey.Value = -1
            lFld_Seq.Value = 2
            lFld_ItemCode.AsString = "ANT"
            lFld_Qty.AsFloat = 2
            lFld_Wastage.AsString = "T"
            lDtl.Post

            lDtl.Append
            lFld_DtlKey.Value = -1
            lFld_DDockey.Value = -1
            lFld_Seq.Value = 3
            lFld_ItemCode.AsString = "COVER"
            lFld_Qty.AsFloat = 3
            lFld_Wastage.AsString = "F"
            lDtl.Post

            BizObject.Save
            BizObject.Close
            MsgBox("Done", MsgBoxStyle.Information)
        End If
        FreeBiz(BizObject)
        FreeBiz(lxFer)
        Logout()
        lbTime.Text = ""
    End Sub

    Private Sub BtnSLIVList_Click(sender As Object, e As EventArgs) Handles btnSLIVList.Click
        Dim RptObject, lDateFrom, lDateTo, lDataSet1, lDataSet2
        Dim tblC1, tblC2 As DataColumn
        Dim drt As DataRelation

        'Step 1: Create Com Server object
        CheckLogin()
        'Step 2: Find and Create the Report Objects
        RptObject = ComServer.RptObjects.Find("Sales.IV.RO")
        'Step 3: Spool parameters
        'RptObject.Params.Find("AgentData").Value              = 'Not use if AllAgent is true
        RptObject.Params.Find("AllAgent").Value = True
        RptObject.Params.Find("AllArea").Value = True
        RptObject.Params.Find("AllCompany").Value = False
        RptObject.Params.Find("AllCurrency").Value = True
        RptObject.Params.Find("AllDocProject").Value = True
        RptObject.Params.Find("AllDocument").Value = True
        RptObject.Params.Find("AllItem").Value = True
        RptObject.Params.Find("AllItemProject").Value = True
        RptObject.Params.Find("AllLocation").Value = True
        RptObject.Params.Find("AllStockGroup").Value = True
        RptObject.Params.Find("AllCompanyCategory").Value = True
        RptObject.Params.Find("AllBatch").Value = True
        If lBuildNo >= 776 Then
            RptObject.Params.Find("AllTariff").Value = True
            'RptObject.Params.Find("TariffData").Value         = 'Not use if AllTariff is true
        End If
        'RptObject.Params.Find("AreaData").Value               = 'Not use if AllArea is true
        'RptObject.Params.Find("CompanyCategoryData").Value    = 'Not use if AllCompanyCategory is true
        RptObject.Params.Find("CompanyData").Value = "300-A0003" '"300-C0001"
        'RptObject.Params.Find("CurrencyData").Value           = 'Not use if AllCurrency is true

        lDateFrom = CDate("January 01, 2019")
        lDateTo = CDate("December 31, 2019")

        RptObject.Params.Find("DateFrom").Value = lDateFrom
        RptObject.Params.Find("DateTo").Value = lDateTo
        'RptObject.Params.Find("DocProjectData").Value          = 'Not use if AllDocProject is true
        'RptObject.Params.Find("DocumentData").Value            = 'Not use if AllDocument is true
        'RptObject.Params.Find("GroupBy").Value                 = 'If you wanted to grouping the data
        'RptObject.Params.Find("CategoryData").Value            = 'Not use if HasCategory is false
        'RptObject.Params.Find("CategoryTpl").Value             = 'For Internal use only
        RptObject.Params.Find("IncludeCancelled").Value = False
        RptObject.Params.Find("HasCategory").Value = False
        'RptObject.Params.Find("ItemData").Value                = 'Not use if AllItem is true
        'RptObject.Params.Find("ItemProjectData").Value         = 'Not use if AllItemProject is true
        'RptObject.Params.Find("LocationData").Value            = 'Not use if AllLocation is true
        'RptObject.Params.Find("ItemCategoryData").Value        = 'For Internal use only
        'RptObject.Params.Find("BatchData").Value               = 'Not use if AllBatch is true
        RptObject.Params.Find("PrintDocumentStyle").Value = False
        RptObject.Params.Find("SelectDate").Value = True
        RptObject.Params.Find("SortBy").Value = "PostDate;DocNo;Code"
        'RptObject.Params.Find("StockGroupData").Value          = 'Not use if AllStockGroup is true

        'Step 4: Perform Report calculation 
        RptObject.CalculateReport()

        lDataSet1 = RptObject.DataSets.Find("cdsMain")
        lDataSet2 = RptObject.DataSets.Find("cdsDocDetail")

        'Step 5 : Convert to Dataset
        ClearTables()

        PrepareData(lDataSet1, "Master")
        PrepareData(lDataSet2, "Detail")

        'Step 6 : Get Relation column
        tblC1 = Tbl.Tables("Master").Columns("Dockey")
        tblC2 = Tbl.Tables("Detail").Columns("DocKey")
        drt = New DataRelation("relation", tblC1, tblC2)

        'Step 7 : Set Grid Info        
        SetGridInfo(drt)

        MsgBox("Done", MsgBoxStyle.Information)

        'Step 8 : Logout after done 
        Logout()
        RptObject = Nothing
    End Sub

    Public Sub PrepareData(ByVal ADataset As Object, AName As String)
        'Tested Aging Master = 119, Detail = 931 => From 2m ~ 3m 15sec To 50 sec to 1m 15sec
        Tbl.Tables.Add(AName)
        ' Add Columns
        Dim col As DataColumn
        Dim lFld As String
        Dim I, J, K As Integer
        Dim dict As New Dictionary(Of Integer, Object)
        Dim dsFld As Object

        For I = 0 To ADataset.Fields.Count - 1
            dict.Add(I, ADataset.Fields.Items(I))
            dsFld = dict.Item(I)
            lFld = dsFld.FieldName
            col = New DataColumn(lFld)
            Tbl.Tables(AName).Columns.Add(col)
        Next

        'Add Rows from the datagridview
        Dim row As DataRow

        J = ADataset.RecordCount
        K = 0

        ADataset.DisableControls
        ADataset.First
        While (Not ADataset.eof)
            K = K + 1
            row = Tbl.Tables(AName).Rows.Add

            For I = 0 To ADataset.Fields.Count - 1
                dsFld = dict.Item(I)
                lFld = dsFld.FieldName
                lbTime.Text = "Insert Grid - " + AName + " " + K.ToString + " of " + J.ToString + " - " + lFld
                row.Item(I) = dsFld.Value
            Next
            ADataset.Next
        End While
    End Sub

    Public Sub SetGridInfo(ByVal drt As DataRelation)
        'Assign relation to dataset
        Tbl.Relations.Add(drt)

        'Bind the Master to the dataset.
        MasterBS.DataSource = Tbl
        MasterBS.DataMember = "Master"

        'Bind the Detail to MasterBind
        DetailBS.DataSource = MasterBS
        DetailBS.DataMember = "relation"

        'Set Datasoure to Grid
        DataGVM.DataSource = MasterBS
        DataGVD.DataSource = DetailBS
    End Sub

    Public Sub ClearTables()
        Tbl.Relations.Clear()
        MasterBS.DataMember = ""
        DetailBS.DataMember = ""
        If (Tbl.Tables.Count <> 0) Then
            Tbl.Tables("Detail").Constraints.Clear()
        End If
        Tbl.Tables.Clear()
    End Sub

    Private Sub BtnDCFDBList_Click(sender As Object, e As EventArgs) Handles btnDCFDBList.Click
        Dim fd As OpenFileDialog = New OpenFileDialog With {
            .Title = "Open DCF File...",
            .InitialDirectory = My.Computer.FileSystem.SpecialDirectories.Desktop,
            .Filter = "DCF File (*.DCF)|*.DCF|All Files (*.*)|*.*",
            .FilterIndex = 1,
            .RestoreDirectory = True
        }

        If fd.ShowDialog() = DialogResult.OK Then
            Dim DCFFile() As String = IO.File.ReadAllLines(fd.FileName)
            Dim SL As New List(Of String)
            Dim Lnstr, RStr As String
            Dim strArr(), RStrArr() As String
            Dim col As DataColumn
            Dim row As DataRow
            Dim I As Integer

            For Each line As String In DCFFile
                SL.Add(line.Trim)
            Next

            Tbl.Tables.Add("DCFList")
            ' Add Columns
            col = New DataColumn("Database")
            Tbl.Tables("DCFList").Columns.Add(col)
            col = New DataColumn("CompanyName")
            Tbl.Tables("DCFList").Columns.Add(col)
            col = New DataColumn("Remark")
            Tbl.Tables("DCFList").Columns.Add(col)
            col = New DataColumn("Version")
            Tbl.Tables("DCFList").Columns.Add(col)

            For I = 2 To SL.Count - 2
                row = Tbl.Tables("DCFList").Rows.Add
                Lnstr = SL.Item(I) 'Get Row Index No 2
                strArr = Lnstr.Split("=")
                'Database
                RStr = strArr(1)
                RStrArr = RStr.Split("""")
                row.Item(0) = RStrArr(1)

                'CompanyName
                RStr = strArr(2)
                RStrArr = RStr.Split("""")
                row.Item(1) = RStrArr(1)

                'Remark
                RStr = strArr(3)
                RStrArr = RStr.Split("""")
                row.Item(2) = RStrArr(1)

                'Version
                RStr = strArr(4)
                RStrArr = RStr.Split("""")
                row.Item(3) = RStrArr(1)
            Next

            'Bind the Master to the dataset.
            MasterBS.DataSource = Tbl
            MasterBS.DataMember = "DCFList"

            'Set Datasoure to Grid
            DataGVM.DataSource = MasterBS
        End If
    End Sub

    Private Sub BtnGetAgent_Click(sender As Object, e As EventArgs) Handles BtnGetAgent.Click
        Dim BizObject, lMain, lDocKey As Object
        Dim strAgentCode As String

        'Step 1: Create Com Server object
        CheckLogin()
        'Step 2: Find and Create the Biz Objects
        BizObject = ComServer.BizObjects.Find("Agent")

        'Step 3: Set Dataset
        lMain = BizObject.DataSets.Find("MainDataSet")
        strAgentCode = edCode.Text.Trim

        'Step 3: Search
        lDocKey = BizObject.FindKeyByRef("CODE", strAgentCode)
        BizObject.Params.Find("CODE").Value = lDocKey

        If IsDBNull(lDocKey) Then
            edDesc.Text = "No Record Found"
        Else
            BizObject.Open
            edDesc.Text = lMain.FindField("DESCRIPTION").value
        End If
        'Step 4: Close        
        BizObject.close

        'Step 5 : Logout after done 
        FreeBiz(BizObject)
        Logout()
    End Sub

    Private Sub BtnSTItem_Click(sender As Object, e As EventArgs) Handles BtnSTItem.Click
        'Dim RptObject, lDateFrom, lDateTo, lDataSet1, lDataSet2 'For Alternative 2
        'Dim tblC1, tblC2 As DataColumn 'For Alternative 2
        'Dim drt As DataRelation 'For Alternative 2
        Dim lDataSet
        Dim lSQL As String

        'Step 1: Login
        CheckLogin()

        'Alternative 1
        lSQL = "SELECT A.*, B.UOM, B.RATE, B.REFCOST, B.REFPRICE, B.ISBASE FROM ST_ITEM A "
        lSQL = lSQL & "INNER JOIN ST_ITEM_UOM B ON (A.CODE=B.CODE) "
        lSQL = lSQL & "WHERE A.ISACTIVE='T' "

        If edCode.Text.Trim <> "" Then
            'Begin if wanted filter by Supplier Code
            lSQL = lSQL & "AND EXISTS (SELECT CODE FROM ST_ITEM_COMPANY C "
            lSQL = lSQL & "              WHERE CTYPE='S' "
            lSQL = lSQL & "              AND COMPANY=" & QuotedStr(edCode.Text)
            lSQL = lSQL & "              AND C.CODE=A.CODE) "
            'End if wanted filter by Supplier Code
        End If

        lSQL = lSQL & "ORDER BY A.CODE, B.RATE"

        lDataSet = ComServer.DBManager.NewDataSet(lSQL)

        PrepareData(lDataSet, "Master")

        'Bind the Master to the dataset.
        MasterBS.DataSource = Tbl
        MasterBS.DataMember = "Master"

        'Set Datasoure to Grid
        DataGVM.DataSource = MasterBS


        'Alternative 2
        ''Step 2: Find and Create the Report Objects
        'RptObject = ComServer.RptObjects.Find("Stock.Item.RO")

        ''Step 3: Spool parameters
        'RptObject.Params.Find("AllItem").AsBoolean = True
        'RptObject.Params.Find("AllStockGroup").AsBoolean = True
        'RptObject.Params.Find("AllCustomerPriceTag").AsBoolean = True
        'RptObject.Params.Find("AllSupplierPriceTag").AsBoolean = True
        ''RptObject.Params.Find("CategoryData").AsBlob            =  'Not use
        ''RptObject.Params.Find("CategoryTpl").AsBlob             =  'Not use
        ''RptObject.Params.Find("CustomerPriceTagData").AsBlob    =  'Not use if AllCustomerPriceTag is True
        ''RptObject.Params.Find("SupplierPriceTagData").AsBlob    =  'Not use if AllSupplierPriceTag is True

        'lDateFrom = CDate("January 01, 2017")
        'lDateTo = CDate("December 31, 2017")

        ''RptObject.Params.Find("DateFrom").AsDate                = lDateFrom 'Not use if SelectDate is False
        ''RptObject.Params.Find("DateTo").AsDate                  = lDateTo
        'RptObject.Params.Find("HasAltStockItem").AsBoolean = False
        'RptObject.Params.Find("HasBarcode").AsBoolean = False
        'RptObject.Params.Find("HasBOM").AsBoolean = False
        'RptObject.Params.Find("HasCategory").AsBoolean = False
        'RptObject.Params.Find("HasCustomerItem").AsBoolean = False
        'RptObject.Params.Find("HasOpeningBalance").AsBoolean = False
        'RptObject.Params.Find("HasPurchasePrice").AsBoolean = False
        'RptObject.Params.Find("HasSellingPrice").AsBoolean = False
        'RptObject.Params.Find("HasSupplierItem").AsBoolean = False
        ''RptObject.Params.Find("ItemData").AsBlob                = 'Not use if AllItem is True
        ''RptObject.Params.Find("ItemCategoryData").AsBlob        = 'Not use if SelectCategory is False
        'RptObject.Params.Find("PrintActive").AsBoolean = True
        'RptObject.Params.Find("PrintInActive").AsBoolean = True
        'RptObject.Params.Find("PrintNonStockControl").AsBoolean = True
        'RptObject.Params.Find("PrintStockControl").AsBoolean = True
        'RptObject.Params.Find("SelectCategory").AsBoolean = False
        'RptObject.Params.Find("SelectDate").AsBoolean = False
        'RptObject.Params.Find("SortBy").AsString = "Code"
        ''RptObject.Params.Find("StockGroupData").AsBlob        =  'Not use if AllStockGroup is True

        ''Step 4: Perform Report calculation 
        'RptObject.CalculateReport()

        'lDataSet1 = RptObject.DataSets.Find("cdsMain")
        'lDataSet2 = RptObject.DataSets.Find("cdsUOM")

        ''Step 5 : Convert to Dataset
        'PrepareData(lDataSet1, "Master")
        'PrepareData(lDataSet2, "Detail")

        ''Step 6 : Get Relation column
        'tblC1 = Tbl.Tables("Master").Columns("Code")
        'tblC2 = Tbl.Tables("Detail").Columns("Code")
        'drt = New DataRelation("relation", tblC1, tblC2)

        ''Step 7 : Set Grid Info
        'SetGridInfo(drt)

        MsgBox("Done", MsgBoxStyle.Information)

        'Step 8 : Logout after done 
        FreeBiz(lDataSet)
        Logout()
        'RptObject = Nothing 'For Alterntive 2 only

    End Sub

    Private Sub BtnComplete_Click(sender As Object, e As EventArgs) Handles BtnComplete.Click
        'This will doing following posting
        '01. Cash Sales
        '02. Sales Credit Note
        '03. Customer Payment With Knock off
        '04. Edit Credit Note Posted in Step 02 & Knock Off
        '05. Customer Refund to Knock off Credit Note
        Dim BizObject, lMain, lDetail, lSN
        Dim lDate As Date

        CheckLogin(0)
        lbTime.Text = "Posting Cash Sales..."
        'Begin Looping yr data
        'Step 2: Find and Create the Biz Objects
        BizObject = ComServer.BizObjects.Find("SL_CS")

        'Step 3: Set Dataset
        lMain = BizObject.DataSets.Find("MainDataSet")  'lMain contains master data
        lDetail = BizObject.DataSets.Find("cdsDocDetail") 'lDetail contains detail data
        lSN = BizObject.DataSets.Find("cdsSerialNumber") 'lSN contains Serial Number data

        'Step 4 : Insert Data - Master
        lDate = CDate("January 1, 2022")
        BizObject.[New]
        lMain.FindField("DocKey").value = -1
        lMain.FindField("DocNo").AsString = "--IV Test--"
        lMain.FindField("DocDate").value = lDate
        lMain.FindField("PostDate").value = lDate
        lMain.FindField("Code").AsString = "300-C0001" 'Customer Account
        lMain.FindField("CompanyName").AsString = "Cash Sales"
        lMain.FindField("Address1").AsString = "" 'Optional
        lMain.FindField("Address2").AsString = "" 'Optional
        lMain.FindField("Address3").AsString = "" 'Optional
        lMain.FindField("Address4").AsString = "" 'Optional
        lMain.FindField("Phone1").AsString = "" 'Optional
        lMain.FindField("Description").AsString = "Sales"

        'Step 5: Insert Data - Detail
        'For Tax Inclusive = True with override Tax Amount
        lDetail.Append
        lDetail.FindField("DtlKey").value = -1
        lDetail.FindField("DocKey").value = -1
        lDetail.FindField("Seq").value = 1
        lDetail.FindField("Account").AsString = "500-000" 'Sales Account
        lDetail.FindField("Description").AsString = "Sales Item A"
        lDetail.FindField("Description3").AsString = "Item A Line 1" & vbCr & "Item A Line 2"
        lDetail.FindField("Qty").AsFloat = 1
        lDetail.FindField("Tax").AsString = "SR"
        lDetail.FindField("TaxRate").AsString = "6%"
        lDetail.FindField("TaxInclusive").value = 0
        lDetail.FindField("UnitPrice").AsFloat = 435
        lDetail.FindField("Amount").AsFloat = 410.37 'Exclding GST Amt
        lDetail.FindField("TaxAmt").AsFloat = 24.63

        lDetail.DisableControls
        lDetail.FindField("TaxInclusive").value = 1
        lDetail.EnableControls

        lDetail.Post

        'For Tax Inclusive = False with override Tax Amount
        lDetail.Append
        lDetail.FindField("DtlKey").value = -1
        lDetail.FindField("DocKey").value = -1
        lDetail.FindField("Seq").value = 2
        lDetail.FindField("Account").AsString = "500-000"
        lDetail.FindField("Description").AsString = "Sales Item B"
        lDetail.FindField("Qty").AsFloat = 1
        lDetail.FindField("Tax").AsString = "SR"
        lDetail.FindField("TaxRate").AsString = "6%"
        lDetail.FindField("TaxInclusive").value = 0
        lDetail.FindField("UnitPrice").AsFloat = 94.43
        lDetail.FindField("Amount").AsFloat = 94.43
        lDetail.FindField("TaxAmt").AsFloat = 5.66
        lDetail.Post

        'For With Item Code
        lDetail.Append
        lDetail.FindField("DtlKey").value = -1
        lDetail.FindField("DocKey").value = -1
        lDetail.FindField("Seq").value = 3
        lDetail.FindField("ItemCode").AsString = "ANT"
        lDetail.FindField("Description").AsString = "Sales Item B"
        'lDetail.FindField("Account").AsString     = "500-000" 'If you wanted override the Sales Account Code
        lDetail.FindField("UOM").AsString = "UNIT"
        lDetail.FindField("Qty").AsFloat = 2
        'lDetail.FindField("DISC").AsString        = "5%+3" 'Optional (eg 5% plus 3 Discount)
        lDetail.FindField("Tax").AsString = "SR"
        lDetail.FindField("TaxRate").AsString = "6%"
        lDetail.FindField("TaxInclusive").value = 0
        lDetail.FindField("UnitPrice").AsFloat = 100
        lDetail.FindField("Amount").AsFloat = 200
        lDetail.FindField("TaxAmt").AsFloat = 12
        lDetail.Post

        'For Item Code with Serial Number
        lDetail.Append
        lDetail.FindField("DTLKEY").Value = -1
        lDetail.FindField("DOCKEY").Value = -1
        lDetail.FindField("SEQ").Value = 4
        lDetail.FindField("ItemCode").AsString = "SN1"
        lDetail.FindField("ACCOUNT").AsString = "500-000"
        lDetail.FindField("DESCRIPTION").AsString = "Sales Serial Number Item"

        lSN.Append
        lSN.FindField("SERIALNUMBER").AsString = "SN-00001"
        lSN.Post

        lSN.Append
        lSN.FindField("SERIALNUMBER").AsString = "SN-00002"
        lSN.Post

        lDetail.FindField("UOM").AsString = "UNIT"
        lDetail.FindField("QTY").AsFloat = 2
        lDetail.FindField("TAX").AsString = "SR"
        lDetail.FindField("TAXINCLUSIVE").Value = 0
        lDetail.FindField("UNITPRICE").AsFloat = 94.43
        lDetail.FindField("TAXAMT").AsFloat = 11.33
        lDetail.FindField("CHANGED").AsString = "F"
        lDetail.Post

        'Step 6: Save Document
        BizObject.Save
        BizObject.Close
        FreeBiz(BizObject)
        'End Looping yr data

        'Step 7: Payment
        lbTime.Text = "Posting Payment..."
        Call InsertARPM("--IV Test--", lDate)

        'Step 8: Credit Note
        lbTime.Text = "Posting Sales Credit Note..."
        Call InsertSLCN(lDate.AddDays(1))

        'Step 9: Refund
        lbTime.Text = "Posting Refund..."
        Call InsertARCF(lDate.AddDays(1))

        'Step 10 : Logout after done 
        MsgBox("Done", MsgBoxStyle.Information)
        Logout()
    End Sub

    Public Sub InsertARPM(AKODocNo As String, ADocDate As Date)
        Dim BizObject, lMain, lDetail, lDate, v(1)
        Dim lIVNO As String
        'Step 2: Find and Create the Biz Objects
        BizObject = ComServer.BizObjects.Find("AR_PM")

        'Step 3: Set Dataset
        lMain = BizObject.DataSets.Find("MainDataSet")   'lMain contains master data
        lDetail = BizObject.DataSets.Find("cdsKnockOff") 'lDetail contains detail data  

        'Step 4 : Posting
        lDate = CDate("January 23, 2022")
        BizObject.[New]
        lMain.FindField("DOCKEY").Value = -1
        lMain.FindField("DocNo").AsString = AKODocNo '"--PM Test--"
        lMain.FindField("CODE").AsString = "300-C0001" 'Customer Account
        lMain.FindField("DocDate").Value = ADocDate 'lDate
        lMain.FindField("PostDate").Value = ADocDate 'lDate
        lMain.FindField("Description").AsString = "Payment for A/c"
        lMain.FindField("PaymentMethod").AsString = "320-000" 'Bank or Cash Account
        lMain.FindField("ChequeNumber").AsString = ""
        lMain.FindField("BankCharge").AsFloat = 0
        lMain.FindField("DocAmt").AsFloat = 200.0
        lMain.FindField("Cancelled").AsString = "F"
        'Step 5: Knock Off IV
        lIVNO = "--IV Test--"
        v(0) = "IV"
        v(1) = AKODocNo 'lIVNO

        If (lDetail.Locate("DocType;DocNo", v, False, False)) Then
            lDetail.Edit
            lDetail.FindField("KOAmt").AsFloat = 147.09 'Partial Knock off
            lDetail.FindField("KnockOff").AsString = "T"
            lDetail.Post
        End If
        'Step 6: Save Document
        BizObject.Save
        BizObject.Close
        FreeBiz(BizObject)
    End Sub

    Public Sub InsertSLCN(ADocDate As Date)
        Dim BizObject, lMain, lDetail, lDate
        'Step 2: Find and Create the Biz Objects
        BizObject = ComServer.BizObjects.Find("SL_CN")

        'Step 3: Set Dataset
        lMain = BizObject.DataSets.Find("MainDataSet")  'lMain contains master data
        lDetail = BizObject.DataSets.Find("cdsDocDetail") 'lDetail contains detail data  

        'Step 4 : Insert Data - Master
        lDate = CDate("January 24, 2018")
        BizObject.[New]
        lMain.FindField("DocKey").value = -1
        lMain.FindField("DocNo").AsString = "--CN Test--"
        lMain.FindField("DocDate").value = ADocDate 'lDate
        lMain.FindField("PostDate").value = ADocDate 'lDate
        lMain.FindField("Code").AsString = "300-C0001"
        lMain.FindField("CompanyName").AsString = "Cash Sales"
        lMain.FindField("Address1").AsString = ""
        lMain.FindField("Address2").AsString = ""
        lMain.FindField("Address3").AsString = ""
        lMain.FindField("Address4").AsString = ""
        lMain.FindField("Phone1").AsString = ""
        lMain.FindField("Description").AsString = "Sales Returned"

        'For With Item Code
        lDetail.Append
        lDetail.FindField("DtlKey").value = -1
        lDetail.FindField("DocKey").value = -1
        lDetail.FindField("ItemCode").AsString = "ANT"
        lDetail.FindField("Description").AsString = "Sales Item B"
        lDetail.FindField("Description2").AsString = "Product Spoil" 'Reason
        lDetail.FindField("Remark1").AsString = "--IV Test--"   'Invoice No
        lDetail.FindField("Remark2").AsString = "01 Jan 2017"   'Invoice Date
        lDetail.FindField("Qty").AsFloat = 1
        lDetail.FindField("Tax").AsString = "SR"
        lDetail.FindField("TaxRate").AsString = "6%"
        lDetail.FindField("TaxInclusive").value = 0
        lDetail.FindField("UnitPrice").AsFloat = 100
        lDetail.FindField("Amount").AsFloat = 100
        lDetail.FindField("TaxAmt").AsFloat = 6
        lDetail.Post

        'Step 6: Save Document
        BizObject.Save
        BizObject.Close
        FreeBiz(BizObject)

        'Step 7: Knock Off Invoice
        lbTime.Text = "Posting Credit Note - Knock Invoice..."
        Call KnockIVCN()
    End Sub

    Public Sub KnockIVCN()
        Dim BizObject, lMain, lDetail, lDocKey, v(1)
        Dim lDocNo, lIVNO As String
        'Step 2: Find and Create the Biz Objects
        BizObject = ComServer.BizObjects.Find("AR_CN")

        'Step 3: Set Dataset
        lMain = BizObject.DataSets.Find("MainDataSet") 'lMain contains master data
        lDetail = BizObject.DataSets.Find("cdsKnockOff") 'lDetail contains Knock off data  

        'Step 4 : Find CN Number
        lDocNo = "--CN Test--"
        lDocKey = BizObject.FindKeyByRef("DocNo", lDocNo)
        BizObject.Params.Find("DocKey").Value = lDocKey

        If Not IsDBNull(lDocKey) Then
            BizObject.Open
            BizObject.Edit
            lMain.Edit
            'Step 5: Knock Off IV
            lIVNO = "--IV Test--"
            v(0) = "IV"
            v(1) = lIVNO

            If (lDetail.Locate("DocType;DocNo", v, False, False)) Then
                lDetail.Edit
                lDetail.FindField("KOAmt").AsFloat = 100 'Partial Knock off
                lDetail.FindField("KnockOff").AsString = "T"
                lDetail.Post
            End If
            'Step 6: Save Document
            BizObject.Save
            BizObject.Close
        End If
        FreeBiz(BizObject)
    End Sub

    Public Sub InsertARCF(ADocDate As Date)
        Dim BizObject, lMain, lDetail, lDate, v(1)
        Dim lIVNO As String
        'Step 2: Find and Create the Biz Objects
        BizObject = ComServer.BizObjects.Find("AR_CF")

        'Step 3: Set Dataset
        lMain = BizObject.DataSets.Find("MainDataSet")   'lMain contains master data
        lDetail = BizObject.DataSets.Find("cdsKnockOff") 'lDetail contains detail data  

        'Step 4 : Posting
        lDate = CDate("January 23, 2018")
        BizObject.[New]
        lMain.FindField("DOCKEY").Value = -1
        lMain.FindField("DocNo").AsString = "--CF Test--"
        lMain.FindField("CODE").AsString = "300-C0001" 'Customer Account
        lMain.FindField("DocDate").Value = ADocDate 'lDate
        lMain.FindField("PostDate").Value = ADocDate 'lDate
        lMain.FindField("Description").AsString = "Payment for A/c"
        lMain.FindField("PaymentMethod").AsString = "320-000" 'Bank or Cash Account
        lMain.FindField("ChequeNumber").AsString = ""
        lMain.FindField("BankCharge").AsFloat = 0
        lMain.FindField("DocAmt").AsFloat = 6.0
        lMain.FindField("Cancelled").AsString = "F"
        'Step 5: Knock Off IV
        lIVNO = "--CN Test--"
        v(0) = "CN"
        v(1) = lIVNO

        If (lDetail.Locate("DocType;DocNo", v, False, False)) Then
            lDetail.Edit
            lDetail.FindField("KOAmt").AsFloat = 4 'Partial Knock off
            lDetail.FindField("KnockOff").AsString = "T"
            lDetail.Post
        End If
        'Step 6: Save Document
        BizObject.Save
        BizObject.Close
        FreeBiz(BizObject)
    End Sub

    Private Sub BtnMthEndFifo_Click(sender As Object, e As EventArgs) Handles BtnMthEndFifo.Click
        'Accuracy : 90% - Due to the figure is base on last run Costing in SQL Accounting
        Dim lSQL, lDataSet1, lDataset2, lDataset3
        Dim s, lDateTo As String
        Dim tblC1, tblC2 As DataColumn
        Dim drt As DataRelation

        'Step 1: Create Com Server object
        CheckLogin()

        lDateTo = "'31 Dec 2017' "
        'Step 2: GetMaxSeq
        lSQL = "SELECT  A.ItemCode, A.Location, A.Batch, MAX(B.Seq) AS Seq, 1 AS CostingMethod "
        lSQL = lSQL & "FROM ST_TR A INNER JOIN ST_TR_FIFO B ON (A.TRANSNO=B.TRANSNO) "
        lSQL = lSQL & "WHERE A.PostDate<=" & lDateTo
        lSQL = lSQL & "And A.ITEMCODE =" & QuotedStr(edCode.Text)
        lSQL = lSQL & " GROUP BY A.ItemCode, A.Location, A.Batch"
        lDataSet1 = ComServer.DBManager.NewDataSet(lSQL)

        s = ""
        lDataSet1.First
        While (Not lDataSet1.Eof)
            s = s & lDataSet1.FindField("SEQ").AsString & ","
            lDataSet1.Next
        End While
        s = s.Remove(s.Length - 1) 'Remove last String

        'Step 3: Get Balance Qty & Up To Date Total Cost
        lSQL = "SELECT A.TRANSNO, A.ItemCode, A.Location, A.Batch, B.QTY, B.COST FROM ST_TR A "
        lSQL = lSQL & "INNER JOIN ST_TR_FIFO B ON (A.TRANSNO=B.TRANSNO) "
        lSQL = lSQL & "WHERE B.COSTTYPE='U' "
        lSQL = lSQL & "AND A.PostDate<= " & lDateTo
        lSQL = lSQL & "And A.ITEMCODE =" & QuotedStr(edCode.Text)
        lSQL = lSQL & " AND B.SEQ IN (" & s & ") "
        lSQL = lSQL & " AND B.QTY<>0 "
        lSQL = lSQL & "ORDER BY A.ItemCode, A.Location, A.Batch"
        lDataset2 = ComServer.DBManager.NewDataSet(lSQL)

        s = ""
        lDataset2.First
        While (Not lDataset2.Eof)
            s = s & lDataset2.FindField("TRANSNO").AsString & ","
            lDataset2.Next
        End While
        s = s.Remove(s.Length - 1) 'Remove last String

        'Step 4 : Get FIFO Detail
        lSQL = "SELECT  TransNo, Cost, SUM(Qty) AS Qty, MIN(CostSeq) AS Seq FROM ST_TR_FIFO "
        lSQL = lSQL & "WHERE CostType='B' "
        lSQL = lSQL & "And ITEMCODE =" & QuotedStr(edCode.Text)
        lSQL = lSQL & " AND TRANSNO IN (" & s & ") "
        lSQL = lSQL & " GROUP BY TransNo, Cost"

        lDataset3 = ComServer.DBManager.NewDataSet(lSQL)

        PrepareData(lDataset2, "Master")
        PrepareData(lDataset3, "Detail")

        'Step 6 : Get Relation column
        tblC1 = Tbl.Tables("Master").Columns("TransNo")
        tblC2 = Tbl.Tables("Detail").Columns("TransNo")
        drt = New DataRelation("relation", tblC1, tblC2)

        'Step 7 : Set Grid Info
        SetGridInfo(drt)

        'Step 8 : Logout after done 
        FreeBiz(lDataSet1)
        FreeBiz(lDataset2)
        FreeBiz(lDataset3)
        Logout()
    End Sub

    Private Sub BtnMthEndWA_Click(sender As Object, e As EventArgs) Handles BtnMthEndWA.Click
        'Accuracy : 90% - Due to the figure is base on last run Costing in SQL Accounting
        Dim lSQL, lDataSet1, lDataset2
        Dim s, lDateTo As String

        'Step 1: Create Com Server object
        CheckLogin()

        lDateTo = "''31 Dec 2017' '"
        'Step 2: GetMaxSeq
        lSQL = "SELECT A.ItemCode, A.Location, A.Batch,  MAX(B.Seq) AS Seq, 2 AS CostingMethod "
        lSQL = lSQL & "FROM ST_TR A INNER JOIN ST_TR_WMA B ON (A.TRANSNO=B.TRANSNO) "
        lSQL = lSQL & "WHERE A.PostDate<=" & lDateTo
        lSQL = lSQL & "And A.ITEMCODE =" & QuotedStr(edCode.Text)
        lSQL = lSQL & " GROUP BY A.ItemCode, A.Location, A.Batch"
        lDataSet1 = ComServer.DBManager.NewDataSet(lSQL)

        s = ""
        lDataSet1.First
        While (Not lDataSet1.Eof)
            s = s & lDataSet1.FindField("SEQ").AsString & ","
            lDataSet1.Next
        End While
        s = s.Remove(s.Length - 1) 'Remove last String

        'Step 3: Get Balance Qty & Up To Date Total Cost
        lSQL = "SELECT A.TRANSNO, A.ItemCode, A.Location, A.Batch, B.UTDQty, B.UTDCost FROM ST_TR A "
        lSQL = lSQL & "INNER JOIN ST_TR_WMA B ON (A.TRANSNO=B.TRANSNO) "
        lSQL = lSQL & "WHERE A.PostDate<= " & lDateTo
        lSQL = lSQL & "And A.ITEMCODE =" & QuotedStr(edCode.Text)
        lSQL = lSQL & " AND B.SEQ IN (" & s & ") "
        lSQL = lSQL & " AND B.UTDQty<>0 "
        lSQL = lSQL & "ORDER BY A.ItemCode, A.Location, A.Batch"
        lDataset2 = ComServer.DBManager.NewDataSet(lSQL)

        PrepareData(lDataset2, "Master")

        'Bind the Master to the dataset.
        MasterBS.DataSource = Tbl
        MasterBS.DataMember = "Master"

        'Set Datasoure to Grid
        DataGVM.DataSource = MasterBS

        'Step 7 : Logout after done 
        FreeBiz(lDataSet1)
        FreeBiz(lDataset2)
        Logout()
    End Sub

    Private Sub BtnOptions_Click(sender As Object, e As EventArgs) Handles BtnOptions.Click
        'CustomerOneCentDiffRounding = Perform Tax / Local Amount Rounding
        'CustomerRTN5CentsCS = 5 Cents Rounding (Cash Sales)
        'CustomerRTN5CentsIV = 5 Cents Rounding (Sales Invoice)
        Dim lSQL, lDataSet

        'Create Com Server object
        CheckLogin()

        'Get Option
        lSQL = "SELECT RNAME, RVALUE FROM SY_REGISTRY "
        lSQL = lSQL & "WHERE RNAME IN ('CustomerOneCentDiffRounding', "
        lSQL = lSQL & "'CustomerRTN5CentsCS', 'CustomerRTN5CentsIV') "
        lDataSet = ComServer.DBManager.NewDataSet(lSQL)

        PrepareData(lDataSet, "Master")

        'Bind the Master to the dataset.
        MasterBS.DataSource = Tbl
        MasterBS.DataMember = "Master"

        'Set Datasoure to Grid
        DataGVM.DataSource = MasterBS

        'Logout after done 
        FreeBiz(lDataSet)
        Logout()
    End Sub

    Private Sub BtnPost3_Click(sender As Object, e As EventArgs) Handles btnPost3.Click
        Dim lMain, lDtl, BizObject, lQty,
            lFld_MDockey, lFld_DocNo, lFld_Code, lFld_DocDate, lFld_PostDate, lFld_TaxDate,
            lFld_Desc, lFld_Cancelled,
            lFld_DDockey, lFld_DtlKey, lFld_Seq, lFld_ItemCode, lFld_Acc, lFld_Qty, lFld_Tax,
            lFld_TaxRate, lFld_TaxInc, lFld_UnitPrice, lFld_TaxAmt

        Dim I, J, R As Integer
        Dim lDate As New Date(Date.Now.Year, 1, 1)
        Dim IP As Random

        edLogout.Checked = True

        For I = 1 To edRecord.Value
            If IsOdd(I) Then
                CheckLogin(0, 0)
            Else
                CheckLogin(1, 1)
            End If

            BizObject = ComServer.BizObjects.Find("SL_CS")
            lMain = BizObject.DataSets.Find("MainDataSet")  'lMain contains master data
            lDtl = BizObject.DataSets.Find("cdsDocDetail") 'lDetail contains detail data

            lFld_MDockey = lMain.FindField("DOCKEY")
            lFld_DocNo = lMain.FindField("DocNo")
            lFld_Code = lMain.FindField("CODE")
            lFld_DocDate = lMain.FindField("DocDate")
            lFld_PostDate = lMain.FindField("PostDate")
            lFld_TaxDate = lMain.FindField("TAXDATE")
            lFld_Desc = lMain.FindField("Description")
            lFld_Cancelled = lMain.FindField("Cancelled")

            lFld_DDockey = lDtl.FindField("DOCKEY")
            lFld_DtlKey = lDtl.FindField("DTLKEY")
            lFld_Seq = lDtl.FindField("SEQ")
            lFld_ItemCode = lDtl.FindField("ItemCode")
            lFld_Acc = lDtl.FindField("Account")
            lFld_Qty = lDtl.FindField("QTY")
            lFld_Tax = lDtl.FindField("TAX")
            lFld_TaxRate = lDtl.FindField("TAXRATE")
            lFld_TaxInc = lDtl.FindField("TAXINCLUSIVE")
            lFld_UnitPrice = lDtl.FindField("UNITPRICE")
            lFld_TaxAmt = lDtl.FindField("TaxAmt")

            lbTime.Text = "Posting Record No : " & I
            BizObject.[New]
            'Begin Append Master
            lFld_MDockey.Value = -1
            lFld_DocNo.AsString = String.Format(edFmt.Text, I)

            IP = New Random
            R = IP.Next(0, edCoCode.Lines.Count)
            lFld_Code.AsString = edCoCode.Lines.GetValue(R)

            If I >= 10 Then
                lDate = lDate.AddDays(I / 10)
            End If
            lFld_DocDate.Value = lDate
            lFld_PostDate.Value = lDate
            lFld_TaxDate.Value = lDate
            lFld_Desc.AsString = "Sales"
            lFld_Cancelled.Value = "F"
            lMain.Post

            'Begin Append Detail
            For J = 1 To edRecordItem.Value
                lDtl.Append
                lFld_DtlKey.Value = -1
                lFld_DDockey.Value = -1
                lFld_Seq.Value = J

                IP = New Random
                R = IP.Next(0, edItem.Lines.Count)
                lFld_ItemCode.AsString = edItem.Lines.GetValue(R)

                IP = New Random
                lQty = IP.Next(1, 10)

                'lFld_Acc.AsString = "500-000" 'Sales Account Code  & can ignore if had itemcode
                lFld_Qty.AsFloat = lQty

                If edWithTax.Checked Then
                    lFld_Tax.AsString = "SR"
                    lFld_TaxRate.AsString = "6%"
                    lFld_TaxInc.Value = 0
                Else
                    lFld_Tax.AsString = ""
                    lFld_TaxRate.AsString = ""
                    lFld_TaxInc.Value = 0
                End If

                lFld_UnitPrice.AsFloat = 100
                If edWithTax.Checked Then
                    lFld_TaxAmt.AsFloat = 0.06 * (lQty * 100) 'TaxRate * (Qty * UnitPrice Excluding Tax)
                Else
                    lFld_TaxAmt.AsFloat = 0
                End If
                lDtl.Post
            Next
            BizObject.Save
            BizObject.Close
            FreeBiz(BizObject)
        Next
        MsgBox("Done", MsgBoxStyle.Information)
        Logout()
    End Sub

    Private Sub BtnValidSKU_Click(sender As Object, e As EventArgs) Handles BtnValidSKU.Click
        Dim lSQL, lDataSet
        Dim B As Boolean

        'Create Com Server object
        CheckLogin()

        'Query Data
        lSQL = "SELECT UOM FROM ST_ITEM_UOM WHERE CODE= " & QuotedStr(edCode.Text)
        lSQL = lSQL & "AND UOM= " & QuotedStr(edDesc.Text)
        lDataSet = ComServer.DBManager.NewDataSet(lSQL)

        B = lDataSet.RecordCount > 0

        edDocNo.Text = If(B, "Is Valid Item Code/SKU", edCode.Text & " is Not Valid Item Code/SKU")

        'Logout after done 
        FreeBiz(lDataSet)
        Logout()
    End Sub

    Private Sub BtnAddSKU_Click(sender As Object, e As EventArgs) Handles BtnAddSKU.Click
        Dim BizObject, lMain, lDtl, lDocKey As Object
        Dim strCode, strDesc As String

        'Step 1: Create Com Server object
        CheckLogin()
        'Step 2: Find and Create the Biz Objects
        BizObject = ComServer.BizObjects.Find("ST_ITEM")

        'Step 3: Set Dataset
        lMain = BizObject.DataSets.Find("MainDataSet")  'lMain contains master data
        lDtl = BizObject.DataSets.Find("cdsUOM")        'lDtl contains UOM data
        strCode = edCode.Text.Trim
        strDesc = edDesc.Text.Trim

        'Step 3: Insert or Update
        lDocKey = BizObject.FindKeyByRef("CODE", strCode)
        If IsDBNull(lDocKey) Then
            BizObject.[New]
            lMain.FindField("CODE").value = strCode
            lMain.FindField("DESCRIPTION").value = strDesc
            lMain.FindField("STOCKGROUP").value = "DEFAULT"
            lMain.FindField("STOCKCONTROL").value = "T"
            lMain.FindField("ISACTIVE").value = "T"

            lDtl.Edit 'For 1St UOM
            lDtl.FindField("UOM").AsString = "PCS"
            lDtl.FindField("Rate").AsFloat = 1
            lDtl.FindField("RefCost").AsFloat = 10.2
            lDtl.FindField("RefPrice").AsFloat = 25
            lDtl.Post

            lDtl.Append 'For 2nd UOM
            lDtl.FindField("UOM").AsString = "CTN"
            lDtl.FindField("Rate").AsFloat = 12
            lDtl.FindField("RefCost").AsFloat = 102
            lDtl.FindField("RefPrice").AsFloat = 240
            lDtl.Post
        Else 'Edit Data if found
            BizObject.Params.Find("Dockey").Value = lDocKey
            BizObject.Open
            BizObject.Edit
            lMain.FindField("DESCRIPTION").value = strDesc

            'Delete all Detail
            While lDtl.RecordCount <> 0
                lDtl.First
                lDtl.Delete
            End While

            'Insert back with new Price
            lDtl.Append 'For 1St UOM
            lDtl.FindField("UOM").AsString = "PCS" 'Make sure this always same as b4 delete data
            lDtl.FindField("Rate").AsFloat = 1     'Make sure this always same as b4 delete data
            lDtl.FindField("RefCost").AsFloat = 22.3
            lDtl.FindField("RefPrice").AsFloat = 52
            lDtl.Post

            lDtl.Append 'For 2nd UOM
            lDtl.FindField("UOM").AsString = "CTN" 'Make sure this always same as b4 delete data
            lDtl.FindField("Rate").AsFloat = 12    'Make sure this always same as b4 delete data
            lDtl.FindField("RefCost").AsFloat = 102.5
            lDtl.FindField("RefPrice").AsFloat = 260.45
            lDtl.Post
        End If
        'Step 4: Save
        BizObject.Save
        BizObject.close
        MsgBox("Done", MsgBoxStyle.Information)
        'Step 5 : Logout after done         
        FreeBiz(BizObject)
        Logout()
    End Sub

    Private Sub BtnOSSO_Click(sender As Object, e As EventArgs) Handles BtnOSSO.Click
        Dim RptObject, lDateFrom, lDateTo, lDataSet1, lDataSet2, lDataSet3
        Dim tblmC1, tblmC2, tbldC1, tbldC2 As DataColumn
        Dim drt As DataRelation

        'Step 1: Create Com Server object
        CheckLogin()
        'Step 2: Find and Create the Report Objects
        RptObject = ComServer.RptObjects.Find("Sales.OutstandingSO.RO")
        'Step 3: Spool parameters
        'RptObject.Params.Find("AgentData").Value            = 'Not use if AllAgent is true
        'RptObject.Params.Find("CompanyCategoryData").Value  = 'Not use if AllCompanyCategory is true
        'RptObject.Params.Find("LocationData").Value         = 'Not use if AllLocation is true
        'RptObject.Params.Find("StockGroupData").Value       = 'Not use if AllStockGroup is true
        RptObject.Params.Find("AllAgent").Value = True
        RptObject.Params.Find("AllArea").Value = True
        RptObject.Params.Find("AllCompany").Value = True
        RptObject.Params.Find("AllDocument").Value = False
        RptObject.Params.Find("AllItem").Value = True
        RptObject.Params.Find("AllItemProject").Value = True
        'RptObject.Params.Find("AreaData").Value              = 'Not use if AllArea is true
        'RptObject.Params.Find("CompanyData").Value           = 'Not use if AllCompany is true

        lDateFrom = CDate("January 01, 2019")
        lDateTo = CDate("December 31, 2019")

        'RptObject.Params.Find("DateFrom").Value              = lDateFrom
        'RptObject.Params.Find("DateTo").Value                = lDateTo
        'RptObject.Params.Find("DeliveryDateFrom").Value      = lDateFrom
        'RptObject.Params.Find("DeliveryDateTo").Value        = lDateTo
        RptObject.Params.Find("DocumentData").Value = "SO-00130" & vbCrLf & "SO-00131"
        'RptObject.Params.Find("GroupBy").Value               = 'If you wanted to grouping the data
        RptObject.Params.Find("IncludeCancelled").Value = False
        'RptObject.Params.Find("ItemData").Value               = 'Not use if AllItem is true
        RptObject.Params.Find("PrintFulfilledItem").Value = True 'Print transfered info
        RptObject.Params.Find("PrintOutstandingItem").Value = True 'Print untransfer info
        'RptObject.Params.Find("ItemProjectData").Value       = 'Not use if AllItemProject is true
        RptObject.Params.Find("SelectDate").Value = False
        RptObject.Params.Find("SelectDeliveryDate").Value = False
        RptObject.Params.Find("SortBy").Value = "DocDate;DocNo;Code"
        RptObject.Params.Find("AllDocProject").Value = True
        RptObject.Params.Find("AllLocation").Value = True
        RptObject.Params.Find("AllCompanyCategory").Value = True
        RptObject.Params.Find("AllBatch").Value = True
        RptObject.Params.Find("HasCategory").Value = False
        RptObject.Params.Find("AllStockGroup").Value = True
        'RptObject.Params.Find("CategoryData").Value          = 'For Internal use only
        'RptObject.Params.Find("CategoryTpl").Value           = 'For Internal use only
        'RptObject.Params.Find("ItemCategoryData").Value      = 'For Internal use only
        'RptObject.Params.Find("DocProjectData").Value        = 'Not use if AllDocProject is true
        'RptObject.Params.Find("BatchData").Value             = 'Not use if AllBatch is true
        If lBuildNo >= 776 Then
            RptObject.Params.Find("AllTariff").Value = True
            'RptObject.Params.Find("TariffData").Value         = 'Not use if AllTariff is true
        End If
        RptObject.Params.Find("TranferDocFilterDate").Value = False
        'Step 4: Perform Report calculation 
        RptObject.CalculateReport()

        lDataSet1 = RptObject.DataSets.Find("cdsMain") 'The outstanding Qty in Smallest UOM
        lDataSet2 = RptObject.DataSets.Find("cdsTransfer") 'Shown Transfer Qty in Smallest UOM

        'To find Actual Outstanding Qty UOM -> Use OutstandingQty (in cdsMain)/Rate (in cdsDocDetail)
        'Link key for cdsMain & cdsDocDetail is Dtlkey
        lDataSet3 = RptObject.DataSets.Find("cdsDocDetail")

        'Step 5 : Convert to Dataset
        ClearTables()

        PrepareData(lDataSet1, "Master")
        PrepareData(lDataSet2, "Detail")

        'Step 6 : Get Relation column
        tblmC1 = Tbl.Tables("Master").Columns("Dockey")
        tblmC2 = Tbl.Tables("Master").Columns("Dtlkey")
        tbldC1 = Tbl.Tables("Detail").Columns("FromDocKey")
        tbldC2 = Tbl.Tables("Detail").Columns("FromDtlKey")
        Dim tblM As DataColumn() = New DataColumn() {tblmC1, tblmC2}
        Dim tblD As DataColumn() = New DataColumn() {tbldC1, tbldC2}


        drt = New DataRelation("relation", tblM, tblD)

        'Step 7 : Set Grid Info
        SetGridInfo(drt)

        MsgBox("Done", MsgBoxStyle.Information)

        'Step 8 : Logout after done 
        Logout()
        RptObject = Nothing
    End Sub

    Public Shared Function ByteToImage(ByVal blob As Byte()) As Bitmap
        Dim mStream As MemoryStream = New MemoryStream()
        Dim pData As Byte() = blob
        mStream.Write(pData, 0, Convert.ToInt32(pData.Length))
        Dim bm As Bitmap = New Bitmap(mStream, False)
        mStream.Dispose()
        Return bm
    End Function

    Private Sub BtnRtf_Click(sender As Object, e As EventArgs) Handles BtnRtf.Click
        Dim lSQL, lDataSet

        'Create Com Server object
        CheckLogin()

        'Query Data
        lSQL = "SELECT Description3, Picture FROM ST_ITEM WHERE CODE= " & QuotedStr(edCode.Text)
        lDataSet = ComServer.DBManager.NewDataSet(lSQL)

        edDesc.Text = lDataSet.FindField("Description3").AsString
        PictureBox1.Image = ByteToImage(lDataSet.FindField("Picture").Value)
        RichTextBox1.Rtf = edDesc.Text

        'Logout after done
        FreeBiz(lDataSet)
        Logout()

    End Sub

    Private Sub BtnDelSKU_Click(sender As Object, e As EventArgs) Handles BtnDelSKU.Click
        Dim BizObject, lDocKey As Object

        'Step 1: Create Com Server object
        CheckLogin()
        'Step 2: Find and Create the Biz Objects
        BizObject = ComServer.BizObjects.Find("ST_ITEM")

        'Step 3: Insert or Update
        lDocKey = BizObject.FindKeyByRef("CODE", edCode.Text.Trim)
        If Not IsDBNull(lDocKey) Then
            BizObject.Params.Find("Dockey").Value = lDocKey
            BizObject.Open
            BizObject.Delete
        End If
        'Step 4: Close
        BizObject.close
        MsgBox("Done", MsgBoxStyle.Information)
        'Step 5 : Logout after done         
        FreeBiz(BizObject)
        Logout()
    End Sub

    Private Sub BtnAddCust_Click(sender As Object, e As EventArgs) Handles BtnAddCust.Click
        Dim BizObject, lMain, lDtl, lDocKey As Object
        Dim strCode, strDesc, v As String

        'Step 1: Create Com Server object
        CheckLogin()
        'Step 2: Find and Create the Biz Objects
        BizObject = ComServer.BizObjects.Find("AR_Customer")

        'Step 3: Set Dataset
        lMain = BizObject.DataSets.Find("MainDataSet")
        lDtl = BizObject.DataSets.Find("cdsBranch")

        strCode = edCode.Text.Trim
        strDesc = edDesc.Text.Trim

        'Step 3: Insert or Update
        lDocKey = BizObject.FindKeyByRef("CODE", strCode)
        If IsDBNull(lDocKey) Then
            BizObject.[New]
            lMain.FindField("CODE").value = strCode
            lMain.FindField("CompanyName").value = strDesc

            'Step 3: Insert Data - Detail
            'For 1st Branch
            lDtl.Edit
            lDtl.FindField("BranchName").AsString = "BILLING"
            lDtl.FindField("Address1").AsString = "Address1"
            lDtl.FindField("Address2").AsString = "Address2"
            lDtl.FindField("Address3").AsString = "Address3"
            lDtl.FindField("Address4").AsString = "Address4"
            lDtl.FindField("Attention").AsString = "Attention"
            lDtl.FindField("Phone1").AsString = "Phone1"
            lDtl.FindField("Fax1").AsString = "Fax1"
            lDtl.FindField("Email").AsString = "EmailAddress"
            lDtl.Post

            'For 2nd Branch
            lDtl.Append
            lDtl.FindField("BranchName").AsString = "Branch1"
            lDtl.FindField("Address1").AsString = "DAddress1"
            lDtl.FindField("Address2").AsString = "DAddress2"
            lDtl.FindField("Address3").AsString = "DAddress3"
            lDtl.FindField("Address4").AsString = "DAddress4"
            lDtl.FindField("Attention").AsString = "DAttention"
            lDtl.FindField("Phone1").AsString = "DPhone1"
            lDtl.FindField("Fax1").AsString = "DFax1"
            lDtl.FindField("Email").AsString = "DEmailAddress"
            lDtl.Post
        Else 'Edit Data if found
            BizObject.Params.Find("CODE").Value = lDocKey
            BizObject.Open
            BizObject.Edit
            lMain.FindField("CompanyName").value = strDesc

            'Step 3 For 1st Branch
            v = "BILLING"

            If (lDtl.Locate("BranchName", v, False, False)) Then
                lDtl.Edit
                lDtl.FindField("Address1").AsString = "Address1-Changed"
                lDtl.FindField("Address2").AsString = "Address2-Changed"
                lDtl.FindField("Address3").AsString = "Address3-Changed"
                lDtl.FindField("Address4").AsString = "Address4-Changed"
                lDtl.FindField("Attention").AsString = "Attention-Changed"
                lDtl.FindField("Phone1").AsString = "Phone1-Changed"
                lDtl.FindField("Fax1").AsString = "Fax1-Changed"
                lDtl.FindField("Email").AsString = "EmailAddress-Changed"
                lDtl.Post
            End If
            'Step 3 For 2nd Branch
            v = "Branch1"

            If (lDtl.Locate("BranchName", v, False, False)) Then
                lDtl.Edit
                lDtl.FindField("Address1").AsString = "DAddress1-Changed"
                lDtl.FindField("Address2").AsString = "DAddress2-Changed"
                lDtl.FindField("Address3").AsString = "DAddress3-Changed"
                lDtl.FindField("Address4").AsString = "DAddress4-Changed"
                lDtl.FindField("Attention").AsString = "DAttention-Changed"
                lDtl.FindField("Phone1").AsString = "DPhone1-Changed"
                lDtl.FindField("Fax1").AsString = "DFax1-Changed"
                lDtl.FindField("Email").AsString = "DEmailAddress-Changed"
                lDtl.Post
            End If
        End If
        'Step 4: Save & Close
        BizObject.Save
        BizObject.close
        MsgBox("Done", MsgBoxStyle.Information)
        'Step 5 : Logout after done         
        FreeBiz(BizObject)
        Logout()
    End Sub

    Private Sub BtnDelCust_Click(sender As Object, e As EventArgs) Handles BtnDelCust.Click
        Dim BizObject, lDocKey As Object

        'Step 1: Create Com Server object
        CheckLogin()
        'Step 2: Find and Create the Biz Objects
        BizObject = ComServer.BizObjects.Find("AR_Customer")

        'Step 3: Insert or Update
        lDocKey = BizObject.FindKeyByRef("CODE", edCode.Text.Trim)
        If Not IsDBNull(lDocKey) Then
            BizObject.Params.Find("Code").Value = lDocKey
            BizObject.Open
            BizObject.Delete
        End If
        'Step 4: Close
        BizObject.close
        MsgBox("Done", MsgBoxStyle.Information)
        'Step 5 : Logout after done         
        FreeBiz(BizObject)
        Logout()
    End Sub

    Private Sub BtnARCustomer_Click(sender As Object, e As EventArgs) Handles BtnARCustomer.Click
        Dim lMain, lDtl
        Dim lSQL As String
        Dim tblC1, tblC2 As DataColumn
        Dim drt As DataRelation

        'Step 1: Login
        CheckLogin()

        lSQL = "SELECT * FROM AR_CUSTOMER "
        lSQL = lSQL & "WHERE STATUS='A' "

        lMain = ComServer.DBManager.NewDataSet(lSQL)

        lSQL = "SELECT * FROM AR_CUSTOMERBRANCH "
        lSQL = lSQL & "WHERE CODE IN (SELECT CODE FROM AR_CUSTOMER "
        lSQL = lSQL & "               WHERE STATUS='A') "

        lDtl = ComServer.DBManager.NewDataSet(lSQL)

        PrepareData(lMain, "Master")
        PrepareData(lDtl, "Detail")

        'Bind the Master to the dataset.
        MasterBS.DataSource = Tbl
        MasterBS.DataMember = "Master"

        'Step 6 : Get Relation column
        tblC1 = Tbl.Tables("Master").Columns("CODE")
        tblC2 = Tbl.Tables("Detail").Columns("CODE")
        drt = New DataRelation("relation", tblC1, tblC2)

        'Step 7 : Set Grid Info
        SetGridInfo(drt)
        FreeBiz(lMain)
        FreeBiz(lDtl)
        Logout()
    End Sub

    Private Sub btnSLCSDel_Click(sender As Object, e As EventArgs) Handles btnSLCSDel.Click
        Dim BizObject, lMain, lDocKey As Object
        'Only can delete If Cash Sales is no Payment Knock off
        'Step 1: Create Com Server object
        CheckLogin()
        'Step 2: Find and Create the Biz Objects
        BizObject = ComServer.BizObjects.Find("SL_CS")
        lMain = BizObject.DataSets.Find("MainDataSet")  'lMain contains master data

        'Step 3: Insert or Update
        lDocKey = BizObject.FindKeyByRef("DocNo", edDocNo.Text.Trim)
        If Not IsDBNull(lDocKey) Then
            BizObject.Params.Find("Dockey").Value = lDocKey
            BizObject.Open

            lMain.Edit()
            lMain.FindField("P_PAYMENTMETHOD").AsString = "" 'Make sure no payment
            BizObject.Save()

            BizObject.Delete
        End If
        'Step 4: Close
        BizObject.close
        MsgBox("Done", MsgBoxStyle.Information)
        'Step 5 : Logout after done         
        FreeBiz(BizObject)
        Logout()
    End Sub

    Private Sub BtnLedger_Click(sender As Object, e As EventArgs) Handles BtnLedger.Click
        Dim lDataSet
        Dim lSQL As String

        'Step 1: Login
        CheckLogin()

        'Alternative 1
        lSQL = "SELECT CODE, DOCDATE, POSTDATE, DESCRIPTION, DESCRIPTION2, "
        lSQL = lSQL & "LOCALDR, LOCALCR, REF1, REF2 FROM GL_TRANS "
        lSQL = lSQL & "WHERE CANCELLED='F' "
        lSQL = lSQL & "AND POSTDATE BETWEEN '01 JAN 2018' "
        lSQL = lSQL & "AND '31 DEC 2018' "

        If edCode.Text.Trim <> "" Then
            'Begin if wanted filter by Account Code
            lSQL = lSQL & "AND CODE=" & QuotedStr(edCode.Text)
            'End if wanted filter by Account Code
        End If

        lSQL = lSQL & " ORDER BY CODE, POSTDATE"

        lDataSet = ComServer.DBManager.NewDataSet(lSQL)

        PrepareData(lDataSet, "Master")

        'Bind the Master to the dataset.
        MasterBS.DataSource = Tbl
        MasterBS.DataMember = "Master"

        'Set Datasoure to Grid
        DataGVM.DataSource = MasterBS


        MsgBox("Done", MsgBoxStyle.Information)

        'Step 8 : Logout after done 
        FreeBiz(lDataSet)
        Logout()
    End Sub

    Private Sub btnARIVList_Click(sender As Object, e As EventArgs) Handles btnARIVList.Click
        Dim RptObject, lDateFrom, lDateTo, lDataSet1, lDataSet2
        Dim tblC1, tblC2 As DataColumn
        Dim drt As DataRelation

        'Step 1: Create Com Server object
        CheckLogin()
        'Step 2: Find and Create the Report Objects
        RptObject = ComServer.RptObjects.Find("Customer.IV.RO")
        'Step 3: Spool parameters
        'RptObject.Params.Find("AgentData").Value              = 'Not use if AllAgent is true
        'RptObject.Params.Find("CompanyCategoryData").Value    = 'Not use if AllCompanyCategory is true
        RptObject.Params.Find("AllAgent").Value = True
        RptObject.Params.Find("AllCompanyCategory").Value = True
        RptObject.Params.Find("AllArea").Value = True
        RptObject.Params.Find("AllCompany").Value = False
        RptObject.Params.Find("AllCurrency").Value = True
        RptObject.Params.Find("AllDocument").Value = True
        RptObject.Params.Find("AllPaymentMethod").Value = True
        'RptObject.Params.Find("AreaData").Value = 'Not use if AllArea is true
        RptObject.Params.Find("CompanyData").Value = "300-A0003"
        'RptObject.Params.Find("CurrencyData").Value = 'Not use if AllCurrency is true
        lDateFrom = CDate("January 01, 2019")
        lDateTo = CDate("December 31, 2019")

        RptObject.Params.Find("DateFrom").Value = lDateFrom
        RptObject.Params.Find("DateTo").Value = lDateTo
        'RptObject.Params.Find("DocumentData").Value = 'Not use if AllDocument is true
        'RptObject.Params.Find("GroupBy").Value = 'if you wanted to grouping
        RptObject.Params.Find("IncludeCancelled").Value = False
        'RptObject.Params.Find("PaymentMethodData").Value = 'Not use if AllPaymentMethod is true
        RptObject.Params.Find("PrintDocumentStyle").Value = False
        RptObject.Params.Find("SelectDate").Value = True
        RptObject.Params.Find("ShowUnappliedAmountOnly").Value = False
        RptObject.Params.Find("SortBy").Value = "DocDate;DocNo;Code"
        RptObject.Params.Find("AllDocProject").Value = True
        RptObject.Params.Find("AllItemProject").Value = True
        'RptObject.Params.Find("DocProjectData").Value = 'Not use if AllDocProject is true
        'RptObject.Params.Find("ItemProjectData").Value = 'Not use if AllItemProject is true


        'Step 4: Perform Report calculation 
        RptObject.CalculateReport()

        lDataSet1 = RptObject.DataSets.Find("cdsMain")
        lDataSet2 = RptObject.DataSets.Find("cdsDocDetail")

        'Step 5 : Convert to Dataset
        ClearTables()

        PrepareData(lDataSet1, "Master")
        PrepareData(lDataSet2, "Detail")

        'Step 6 : Get Relation column
        tblC1 = Tbl.Tables("Master").Columns("Dockey")
        tblC2 = Tbl.Tables("Detail").Columns("DocKey")
        drt = New DataRelation("relation", tblC1, tblC2)

        'Step 7 : Set Grid Info        
        SetGridInfo(drt)

        MsgBox("Done", MsgBoxStyle.Information)

        'Step 8 : Logout after done 
        Logout()
        RptObject = Nothing
    End Sub

    Private Sub btnSNBal_Click(sender As Object, e As EventArgs) Handles btnSNBal.Click
        Dim lSQL, lDataSet

        'Step 1: Create Com Server object
        CheckLogin()

        'Step 2: Get DocNo
        lSQL = "SELECT ItemCode, Location, Batch, SerialNumber, SUM(Qty) Qty  FROM ST_TR_SN "

        If edCode.Text.Trim <> "" Then
            lSQL = lSQL & "WHERE ITEMCODE=" & QuotedStr(edCode.Text)
        End If

        lSQL = lSQL & " GROUP BY ItemCode, Location, Batch, SerialNumber"
        lSQL = lSQL & " HAVING SUM(Qty) > 0"

        lDataSet = ComServer.DBManager.NewDataSet(lSQL)

        PrepareData(lDataSet, "Master")

        'Bind the Master to the dataset.
        MasterBS.DataSource = Tbl
        MasterBS.DataMember = "Master"

        'Set Datasoure to Grid
        DataGVM.DataSource = MasterBS

        MsgBox("Done", MsgBoxStyle.Information)

        FreeBiz(lDataSet)
        Logout()
    End Sub

    Private Sub BtnARDP_Click(sender As Object, e As EventArgs) Handles BtnARDP.Click
        Dim BizObject, lMain, lDate

        CheckLogin(0)
        lbTime.Text = "Posting AR Deposit..."
        'Step 2: Find and Create the Biz Objects
        BizObject = ComServer.BizObjects.Find("AR_DP")

        'Step 3: Set Dataset
        lMain = BizObject.DataSets.Find("MainDataSet")  'lMain contains master data

        'Begin Looping yr data
        'Step 4 : Insert Data - Master
        lDate = CDate("January 1, 2019")
        BizObject.[New]
        lMain.FindField("DocKey").value = -1
        lMain.FindField("DocNo").AsString = "--DP Test--"
        lMain.FindField("DocDate").value = lDate
        lMain.FindField("PostDate").value = lDate
        lMain.FindField("TaxDate").value = lDate
        lMain.FindField("Code").AsString = "300-C0001" 'Customer Account
        lMain.FindField("DEPOSITACCOUNT").AsString = "PREPAYMENT" 'Prepayment Account
        lMain.FindField("PaymentMethod").AsString = "320-000" 'Bank or Cash account
        lMain.FindField("Description").AsString = "Deposit For Account"
        lMain.FindField("ChequeNumber").AsString = ""
        lMain.FindField("BankCharge").Value = 0.00
        lMain.FindField("DocAmt").Value = 1000.0

        'Step 6: Save Document
        BizObject.Save
        BizObject.Close
        'End Looping yr data

        'Step 7 : Logout after done 
        MsgBox("Done", MsgBoxStyle.Information)
        FreeBiz(BizObject)
        Logout()
    End Sub

    Private Sub BtnDP2PM_Click(sender As Object, e As EventArgs) Handles BtnDP2PM.Click
        Dim BizObject, lMain, lDetail, lDate, v(1), lDataSet
        Dim lIVNO, lSQL As String

        CheckLogin(0)
        lbTime.Text = "Check Deposit Number..."
        'Query Data
        lSQL = "SELECT DOCKEY FROM AR_DP "
        lSQL = lSQL & "WHERE DOCNO='--DP Test--' "
        lDataSet = ComServer.DBManager.NewDataSet(lSQL)

        If lDataSet.RecordCount > 0 Then
            lbTime.Text = "Posting AR Payment..."
            'Step 2: Find and Create the Biz Objects
            BizObject = ComServer.BizObjects.Find("AR_PM")

            'Step 3: Set Dataset
            lMain = BizObject.DataSets.Find("MainDataSet")  'lMain contains master data
            lDetail = BizObject.DataSets.Find("cdsKnockOff") 'lDetail contains detail data  

            'Step 4 : Insert Data - Master
            lDate = CDate("January 1, 2019")
            BizObject.[New]
            lMain.FindField("DocKey").value = -1
            lMain.FindField("DocNo").AsString = "--DP2PM Test--"
            lMain.FindField("CODE").AsString = "300-C0001" 'Customer Account
            lMain.FindField("DocDate").Value = lDate
            lMain.FindField("PostDate").Value = lDate
            lMain.FindField("Description").AsString = "Payment for A/c"
            lMain.FindField("PaymentMethod").AsString = "PREPAYMENT" 'Prepayment Account
            lMain.FindField("DocAmt").AsFloat = 200.0
            lMain.FindField("FROMDOCTYPE").AsString = "DP"
            lMain.FindField("FROMDOCKEY").Value = lDataSet.FindField("Dockey").AsFloat 'Transfer from Deposit
            lMain.FindField("Cancelled").AsString = "F"

            'Step 5: Knock Off IV
            lIVNO = '"--IV Test--"
            v(0) = "IV"
            v(1) = lIVNO

            If (lDetail.Locate("DocType;DocNo", v, False, False)) Then
                lDetail.Edit
                lDetail.FindField("KOAmt").AsFloat = 147.09 'Partial Knock off
                lDetail.FindField("KnockOff").AsString = "T"
                lDetail.Post
            End If
            'Step 6: Save Document
            BizObject.Save
            BizObject.Close
            FreeBiz(BizObject)
        End If

        'Step 7 : Logout after done 
        MsgBox("Done", MsgBoxStyle.Information)
        Logout()
    End Sub

    Private Sub BtnDPRefund_Click(sender As Object, e As EventArgs) Handles BtnDPRefund.Click
        Dim BizObject, lMain, lDate, lDataSet
        Dim lSQL As String

        CheckLogin(0)
        lbTime.Text = "Check Deposit Number..."
        'Query Data
        lSQL = "SELECT DOCKEY FROM AR_DP "
        lSQL = lSQL & "WHERE DOCNO='--DP Test--' "
        lDataSet = ComServer.DBManager.NewDataSet(lSQL)

        If lDataSet.RecordCount > 0 Then
            lbTime.Text = "Posting Deposit Refund..."
            'Step 2: Find and Create the Biz Objects
            BizObject = ComServer.BizObjects.Find("AR_DPDTL_REFUND")

            'Step 3: Set Dataset
            lMain = BizObject.DataSets.Find("MainDataSet")  'lMain contains master data

            'Step 4 : Insert Data - Master
            lDate = CDate("January 1, 2019")
            BizObject.[New]
            lMain.FindField("DocKey").value = lDataSet.FindField("Dockey").AsFloat
            lMain.FindField("Account").AsString = "320-000" 'Bank or Cash account
            lMain.FindField("DocDate").value = lDate
            lMain.FindField("PostDate").value = lDate
            lMain.FindField("Description").AsString = "Deposit Refund"
            lMain.FindField("ChequeNumber").AsString = ""
            lMain.FindField("BankCharge").Value = 0.00
            lMain.FindField("PAYMENTAMOUNT").Value = 500.0

            'Step 5: Save Document
            BizObject.Save
            BizObject.Close
            FreeBiz(BizObject)
        End If

        'Step 6 : Logout after done 
        MsgBox("Done", MsgBoxStyle.Information)
        Logout()
    End Sub

    Private Sub BtnDPForfeit_Click(sender As Object, e As EventArgs) Handles BtnDPForfeit.Click
        Dim BizObject, lMain, lDate, lDataSet
        Dim lSQL As String

        CheckLogin(0)
        lbTime.Text = "Check Deposit Number..."
        'Query Data
        lSQL = "SELECT DOCKEY FROM AR_DP "
        lSQL = lSQL & "WHERE DOCNO='--DP Test--' "
        lDataSet = ComServer.DBManager.NewDataSet(lSQL)

        If lDataSet.RecordCount > 0 Then
            lbTime.Text = "Posting Deposit Forfeit..."
            'Step 2: Find and Create the Biz Objects
            BizObject = ComServer.BizObjects.Find("AR_DPDTL_FORFEIT")

            'Step 3: Set Dataset
            lMain = BizObject.DataSets.Find("MainDataSet")  'lMain contains master data

            'Step 4 : Insert Data - Master
            lDate = CDate("January 1, 2019")
            BizObject.[New]
            lMain.FindField("DocKey").value = lDataSet.FindField("Dockey").AsFloat
            lMain.FindField("Account").AsString = "532-000" 'Forfeit account
            lMain.FindField("DocDate").value = lDate
            lMain.FindField("PostDate").value = lDate
            lMain.FindField("Description").AsString = "Deposit Forfeit"
            lMain.FindField("ChequeNumber").AsString = ""
            lMain.FindField("BankCharge").Value = 0.00
            lMain.FindField("Amount").Value = 150.0

            'Step 5: Save Document
            BizObject.Save
            BizObject.Close
            FreeBiz(BizObject)
        End If
        'Step 6 : Logout after done 
        MsgBox("Done", MsgBoxStyle.Information)
        Logout()
    End Sub

    Private Sub BtnDO2IV_Click(sender As Object, e As EventArgs) Handles BtnDO2IV.Click
        Dim BizObject, lMain, lDetail, lxFer, lDate,
            lFld_MDockey, lFld_DocNo,
            lFld_Code, lFld_DocDate, lFld_PostDate, lFld_CoName, lFld_Desc,
            lFld_DDockey, lFld_DtlKey, lFld_Seq, lFld_ItemCode, lFld_DDesc,
            lFld_FromDocType, lFld_FromDockey, lFld_FromDtlkey,
            lFld_Qty, lFld_UOM, lFld_Tax, lFld_TaxRate, lFld_TaxInc,
            lFld_UPrice, lFld_Amt, lFld_TaxAmt
        Dim lSQL As String

        CheckLogin(0)
        lbTime.Text = "Posting Delivery Order..."
        'Step 2: Find and Create the Biz Objects
        BizObject = ComServer.BizObjects.Find("SL_DO")

        'Step 3: Set Dataset
        lMain = BizObject.DataSets.Find("MainDataSet")  'lMain contains master data
        lDetail = BizObject.DataSets.Find("cdsDocDetail") 'lDetail contains detail data  

        lFld_MDockey = lMain.FindField("DocKey")
        lFld_DocNo = lMain.FindField("DocNo")
        lFld_DocDate = lMain.FindField("DocDate")
        lFld_PostDate = lMain.FindField("PostDate")
        lFld_Code = lMain.FindField("Code")
        lFld_CoName = lMain.FindField("CompanyName")
        lFld_Desc = lMain.FindField("Description")

        lFld_DDockey = lDetail.FindField("DocKey")
        lFld_DtlKey = lDetail.FindField("DtlKey")
        lFld_Seq = lDetail.FindField("Seq")
        lFld_ItemCode = lDetail.FindField("ItemCode")
        lFld_DDesc = lDetail.FindField("Description")
        lFld_Qty = lDetail.FindField("Qty")
        lFld_UOM = lDetail.FindField("UOM")
        lFld_Tax = lDetail.FindField("Tax")
        lFld_TaxRate = lDetail.FindField("TaxRate")
        lFld_TaxInc = lDetail.FindField("TaxInclusive")
        lFld_UPrice = lDetail.FindField("UnitPrice")
        lFld_Amt = lDetail.FindField("Amount")
        lFld_TaxAmt = lDetail.FindField("TaxAmt")

        'Step 4 : Insert Data - Master
        lDate = CDate("January 1, 2019")
        BizObject.[New]
        lFld_MDockey.value = -1
        lFld_DocNo.AsString = "--DO Test--"
        lFld_DocDate.value = lDate
        lFld_PostDate.value = lDate
        lFld_Code.AsString = "300-C0001" 'Customer Account
        lFld_CoName.AsString = "Cash Sales"
        'lMain.FindField("Address1").AsString = "" 'Optional
        'lMain.FindField("Address2").AsString = "" 'Optional
        'lMain.FindField("Address3").AsString = "" 'Optional
        'lMain.FindField("Address4").AsString = "" 'Optional
        'lMain.FindField("Phone1").AsString = ""   'Optional
        lFld_Desc.AsString = "Delivery Order"

        'Step 5 Insert Data - Detail
        lDetail.Append()
        lFld_DtlKey.value = -1
        lFld_DDockey.value = -1
        lFld_Seq.value = 1
        lFld_ItemCode.AsString = "ANT"
        lFld_DDesc.AsString = "Sales Item A"
        'lDetail.FindField("Account").AsString     = "500-000" 'If you wanted override the Sales Account Code            
        lFld_UOM.AsString = "UNIT"
        lFld_Qty.AsFloat = 2
        'lDetail.FindField("DISC").AsString        = "5%+3" 'Optional(eg 5% plus 3 Discount)
        lFld_Tax.AsString = "SV"
        lFld_TaxRate.AsString = "6%"
        lFld_TaxInc.value = 0
        lFld_UPrice.AsFloat = 100
        lFld_Amt.AsFloat = 200
        lFld_TaxAmt.AsFloat = 12
        lDetail.Post()

        lDetail.Append()
        lFld_DtlKey.value = -1
        lFld_DDockey.value = -1
        lFld_Seq.value = 2
        lFld_ItemCode.AsString = "COVER"
        lFld_DDesc.AsString = "Sales Item B"
        lFld_UOM.AsString = "UNIT"
        lFld_Qty.AsFloat = 3
        lFld_Tax.AsString = "SV"
        lFld_TaxRate.AsString = "6%"
        lFld_TaxInc.value = 0
        lFld_UPrice.AsFloat = 10
        lFld_Amt.AsFloat = 30
        lFld_TaxAmt.AsFloat = 1.8
        lDetail.Post()

        'Step 6 Save Document
        BizObject.Save()
        BizObject.Close()

        'Check Is Transfered or not
        lbTime.Text = "Check Transfer Status..."
        lSQL = "SELECT DocKey FROM SL_IVDTL "
        lSQL = lSQL & "WHERE FromDocKey IN (SELECT DocKey FROM SL_DO  "
        lSQL = lSQL & "WHERE DocNo='--DO Test--' "
        lSQL = lSQL & "AND Cancelled='F') "
        lSQL = lSQL & "AND FromDocType='DO' "
        lxFer = ComServer.DBManager.NewDataSet(lSQL)

        If lxFer.RecordCount = 0 Then
            'Get DO Information
            lSQL = "SELECT * FROM SL_DODTL "
            lSQL = lSQL & "WHERE DocKey IN (SELECT DocKey FROM SL_DO  "
            lSQL = lSQL & "WHERE DocNo='--DO Test--') "
            lSQL = lSQL & "ORDER BY SEQ "
            lxFer = ComServer.DBManager.NewDataSet(lSQL)

            lbTime.Text = "Posting Invoice..."
            'Find And Create the Biz Objects
            BizObject = ComServer.BizObjects.Find("SL_IV")

            'Set Dataset
            lMain = BizObject.DataSets.Find("MainDataSet")    'lMain contains master data
            lDetail = BizObject.DataSets.Find("cdsDocDetail") 'lDetail contains detail data  

            lFld_MDockey = lMain.FindField("DocKey")
            lFld_DocNo = lMain.FindField("DocNo")
            lFld_DocDate = lMain.FindField("DocDate")
            lFld_PostDate = lMain.FindField("PostDate")
            lFld_Code = lMain.FindField("Code")
            lFld_CoName = lMain.FindField("CompanyName")
            lFld_Desc = lMain.FindField("Description")

            lFld_DDockey = lDetail.FindField("DocKey")
            lFld_DtlKey = lDetail.FindField("DtlKey")
            lFld_Seq = lDetail.FindField("Seq")
            lFld_ItemCode = lDetail.FindField("ItemCode")
            lFld_DDesc = lDetail.FindField("Description")
            lFld_Qty = lDetail.FindField("Qty")
            lFld_UOM = lDetail.FindField("UOM")
            lFld_Tax = lDetail.FindField("Tax")
            lFld_TaxRate = lDetail.FindField("TaxRate")
            lFld_TaxInc = lDetail.FindField("TaxInclusive")
            lFld_UPrice = lDetail.FindField("UnitPrice")
            lFld_Amt = lDetail.FindField("Amount")
            lFld_TaxAmt = lDetail.FindField("TaxAmt")
            lFld_FromDocType = lDetail.FindField("FromDocType")
            lFld_FromDockey = lDetail.FindField("FromDockey")
            lFld_FromDtlkey = lDetail.FindField("FromDtlKey")

            lbTime.Text = "Transfer DO to IV..."
            lDate = CDate("January 10, 2019")
            BizObject.[New]
            lFld_MDockey.value = -1
            lFld_DocNo.AsString = "--IV Test--"
            lFld_DocDate.value = lDate
            lFld_PostDate.value = lDate
            lFld_Code.AsString = "300-C0001" 'Customer Account
            lFld_CoName.AsString = "Cash Sales"
            'lMain.FindField("Address1").AsString = "" 'Optional
            'lMain.FindField("Address2").AsString = "" 'Optional
            'lMain.FindField("Address3").AsString = "" 'Optional
            'lMain.FindField("Address4").AsString = "" 'Optional
            'lMain.FindField("Phone1").AsString = ""   'Optional
            lFld_Desc.AsString = "Invoice"

            lxFer.First
            While (Not lxFer.eof)
                lDetail.Append()
                lFld_DtlKey.value = -1
                lFld_DDockey.value = -1
                lFld_Seq.value = lxFer.FindField("Seq").Value
                lFld_ItemCode.AsString = lxFer.FindField("ItemCode").AsString
                lFld_DDesc.AsString = lxFer.FindField("Description").AsString
                lFld_UOM.AsString = lxFer.FindField("UOM").AsString
                lFld_Qty.AsFloat = lxFer.FindField("Qty").AsFloat
                lFld_Tax.AsString = lxFer.FindField("Tax").AsString
                lFld_TaxRate.AsString = lxFer.FindField("TaxRate").AsString
                lFld_TaxInc.value = lxFer.FindField("TaxInclusive").Value
                lFld_UPrice.AsFloat = lxFer.FindField("UnitPrice").AsFloat
                lFld_Amt.AsFloat = lxFer.FindField("Amount").AsFloat
                lFld_TaxAmt.AsFloat = lxFer.FindField("TaxAmt").AsFloat
                lFld_FromDocType.AsString = "DO"
                lFld_FromDockey.Value = lxFer.FindField("DocKey").Value
                lFld_FromDtlkey.Value = lxFer.FindField("DtlKey").Value
                lDetail.Post()
                lxFer.Next
            End While
            BizObject.Save()
            BizObject.Close()
            MessageBox.Show("Done", "Status", MessageBoxButtons.OK, MessageBoxIcon.Information)
        End If
        FreeBiz(BizObject)
        FreeBiz(lxFer)
        Logout()
        lbTime.Text = ""
    End Sub

    Private Sub BtnSTAJ_Click(sender As Object, e As EventArgs) Handles BtnSTAJ.Click
        Dim lDate, lMain, lDtl, BizObject,
            lFld_MDockey, lFld_DocNo, lFld_DocDate, lFld_PostDate,
            lFld_Desc, lFld_Cancelled,
            lFld_DDockey, lFld_DtlKey, lFld_Seq, lFld_ItemCode, lFld_Qty,
            lFld_DDesc, lFld_UCost, lFld_UOM

        CheckLogin(0)

        BizObject = ComServer.BizObjects.Find("ST_AJ")
        lMain = BizObject.DataSets.Find("MainDataSet")  'lMain contains master data
        lDtl = BizObject.DataSets.Find("cdsDocDetail") 'lDetail contains detail data

        lFld_MDockey = lMain.FindField("DOCKEY")
        lFld_DocNo = lMain.FindField("DocNo")
        lFld_DocDate = lMain.FindField("DocDate")
        lFld_PostDate = lMain.FindField("PostDate")
        lFld_Desc = lMain.FindField("Description")
        lFld_Cancelled = lMain.FindField("Cancelled")

        lFld_DDockey = lDtl.FindField("DOCKEY")
        lFld_DtlKey = lDtl.FindField("DTLKEY")
        lFld_Seq = lDtl.FindField("SEQ")
        lFld_ItemCode = lDtl.FindField("ItemCode")
        lFld_Qty = lDtl.FindField("QTY")
        lFld_DDesc = lDtl.FindField("DESCRIPTION")
        lFld_UCost = lDtl.FindField("UnitCost")
        lFld_UOM = lDtl.FindField("UOM")

        lDate = CDate("January 1, 2020")

        BizObject.[New]
        'Begin Append Master
        lFld_MDockey.Value = -1
        lFld_DocNo.AsString = "--AJ Test--"
        lFld_DocDate.Value = lDate
        lFld_PostDate.Value = lDate
        lFld_Desc.AsString = "Stock Adjustment Description"
        lFld_Cancelled.AsString = "F"

        lDtl.Append
        lFld_DtlKey.Value = -1
        lFld_DDockey.Value = -1
        lFld_Seq.Value = 1
        lFld_ItemCode.AsString = "ANT"
        lFld_DDesc.AsString = "Adjust IN Item"
        lFld_UOM.AsString = "UNIT"
        lFld_Qty.AsFloat = 3
        lFld_UCost.AsFloat = 25.15 'Only IN need UnitCost
        lDtl.Post

        lDtl.Append
        lFld_DtlKey.Value = -1
        lFld_DDockey.Value = -1
        lFld_Seq.Value = 2
        lFld_ItemCode.AsString = "E-BAT"
        lFld_DDesc.AsString = "Adjust OUT Item"
        lFld_UOM.AsString = "UNIT"
        lFld_Qty.AsFloat = -4
        lDtl.Post

        BizObject.Save
        BizObject.Close
        MsgBox("Done", MsgBoxStyle.Information)
        FreeBiz(BizObject)
        Logout()
    End Sub

    Private Sub BtnSTXF_Click(sender As Object, e As EventArgs) Handles BtnSTXF.Click
        Dim lDate, lMain, lDtl, BizObject,
            lFld_MDockey, lFld_DocNo, lFld_DocDate, lFld_PostDate,
            lFld_Desc, lFld_Cancelled,
            lFld_DDockey, lFld_DtlKey, lFld_Seq, lFld_ItemCode, lFld_Qty, lFld_UOM,
            lFld_DDesc, lFld_FromLoc, lFld_ToLoc

        CheckLogin(0)

        BizObject = ComServer.BizObjects.Find("ST_XF")
        lMain = BizObject.DataSets.Find("MainDataSet")  'lMain contains master data
        lDtl = BizObject.DataSets.Find("cdsDocDetail") 'lDetail contains detail data

        lFld_MDockey = lMain.FindField("DOCKEY")
        lFld_DocNo = lMain.FindField("DocNo")
        lFld_DocDate = lMain.FindField("DocDate")
        lFld_PostDate = lMain.FindField("PostDate")
        lFld_Desc = lMain.FindField("Description")
        lFld_Cancelled = lMain.FindField("Cancelled")

        lFld_DDockey = lDtl.FindField("DOCKEY")
        lFld_DtlKey = lDtl.FindField("DTLKEY")
        lFld_Seq = lDtl.FindField("SEQ")
        lFld_ItemCode = lDtl.FindField("ItemCode")
        lFld_Qty = lDtl.FindField("QTY")
        lFld_DDesc = lDtl.FindField("DESCRIPTION")
        lFld_UOM = lDtl.FindField("UOM")
        lFld_FromLoc = lDtl.FindField("FROMLOCATION")
        lFld_ToLoc = lDtl.FindField("TOLOCATION")

        lDate = CDate("January 1, 2020")

        BizObject.[New]
        'Begin Append Master
        lFld_MDockey.Value = -1
        lFld_DocNo.AsString = "--XF Test--"
        lFld_DocDate.Value = lDate
        lFld_PostDate.Value = lDate
        lFld_Desc.AsString = "Stock Transfer Description"
        lFld_Cancelled.AsString = "F"

        lDtl.Append
        lFld_DtlKey.Value = -1
        lFld_DDockey.Value = -1
        lFld_Seq.Value = 1
        lFld_ItemCode.AsString = "ANT"
        lFld_DDesc.AsString = "ANTENNA"
        lFld_UOM.AsString = "UNIT"
        lFld_Qty.AsFloat = 3
        lFld_FromLoc.AsString = "----"
        lFld_ToLoc.AsString = "BALAKONG"
        lDtl.Post

        lDtl.Append
        lFld_DtlKey.Value = -1
        lFld_DDockey.Value = -1
        lFld_Seq.Value = 2
        lFld_ItemCode.AsString = "E-BAT"
        lFld_DDesc.AsString = "ERICSSON BATTERY"
        lFld_UOM.AsString = "UNIT"
        lFld_Qty.AsFloat = 4
        lFld_FromLoc.AsString = "KL"
        lFld_ToLoc.AsString = "BC"
        lDtl.Post

        BizObject.Save
        BizObject.Close
        MsgBox("Done", MsgBoxStyle.Information)
        FreeBiz(BizObject)
        Logout()
    End Sub

    Private Sub BtnGLJE_Click(sender As Object, e As EventArgs) Handles BtnGLJE.Click
        Dim BizObject, lMain, lDetail, lDate

        'Step 1: Create Com Server object
        CheckLogin()

        'Step 2: Find and Create the Biz Objects
        BizObject = ComServer.BizObjects.Find("GL_JE")

        'Step 3: Set Dataset
        lMain = BizObject.DataSets.Find("MainDataSet")  'lMain contains master data
        lDetail = BizObject.DataSets.Find("cdsDocDetail") 'lDetail contains detail data  

        'Step 4 : Insert Data - Master
        lDate = CDate("January 23, 2020")
        BizObject.[New]
        lMain.FindField("DocKey").value = -1
        lMain.FindField("DocNo").value = "--JV Test--"
        lMain.FindField("DocDate").value = lDate
        lMain.FindField("PostDate").value = lDate
        lMain.FindField("Description").value = "testing desc header"
        lMain.Post


        'Step 6: Append Detail
        lDetail.Append
        lDetail.FindField("DtlKey").value = -1
        lDetail.FindField("Code").value = "610-1000" 'Account GL Code
        lDetail.FindField("Description").value = "testing desc1"
        lDetail.FindField("Project").value = "P12W1"
        lDetail.FindField("Tax").value = ""
        lDetail.FindField("TaxInclusive").value = 0
        lDetail.FindField("LocalDR").value = 200
        lDetail.FindField("DR").value = 200
        lDetail.Post

        lDetail.Append
        lDetail.FindField("DtlKey").value = -1
        lDetail.FindField("Code").value = "605-200"
        lDetail.FindField("Description").value = "testing desc2"
        lDetail.FindField("Project").value = "P13W1"
        lDetail.FindField("Tax").value = ""
        lDetail.FindField("TaxInclusive").value = 0
        lDetail.FindField("LocalCR").value = 200
        lDetail.FindField("CR").value = 200
        lDetail.Post

        lDetail.Append
        lDetail.FindField("DtlKey").value = -1
        lDetail.FindField("Code").value = "610-000"
        lDetail.FindField("Description").value = "testing desc3"
        lDetail.FindField("Project").value = "P12W1"
        lDetail.FindField("Tax").value = ""
        lDetail.FindField("TaxInclusive").value = 0
        lDetail.FindField("LocalDR").value = 500.1
        lDetail.FindField("DR").value = 500.1
        lDetail.Post

        lDetail.Append
        lDetail.FindField("DtlKey").value = -1
        lDetail.FindField("Code").value = "605-300"
        lDetail.FindField("Description").value = "testing desc4"
        lDetail.FindField("Project").value = "P13W1"
        lDetail.FindField("Tax").value = ""
        lDetail.FindField("TaxInclusive").value = 0
        lDetail.FindField("LocalCR").value = 500.1
        lDetail.FindField("CR").value = 500.1
        lDetail.Post

        'Step 7: Save Document
        BizObject.Save
        BizObject.Close
        MsgBox("Done", MsgBoxStyle.Information)
        FreeBiz(BizObject)
        Logout()
    End Sub

    Private Sub BtnGLPV_Click(sender As Object, e As EventArgs) Handles BtnGLPV.Click
        Dim BizObject, lMain, lDetail, lDate

        'Step 1: Create Com Server object
        CheckLogin()

        'Step 2: Find and Create the Biz Objects
        BizObject = ComServer.BizObjects.Find("GL_PV")

        'Step 3: Set Dataset
        lMain = BizObject.DataSets.Find("MainDataSet")  'lMain contains master data
        lDetail = BizObject.DataSets.Find("cdsDocDetail") 'lDetail contains detail data  

        'Step 4 : Insert Data - Master
        lDate = CDate("January 23, 2020")
        BizObject.[New]
        lMain.FindField("DOCKEY").Value = -1
        lMain.FindField("DocNo").AsString = "--CB PV Test--"
        lMain.FindField("DocDate").Value = lDate
        lMain.FindField("PostDate").Value = lDate
        lMain.FindField("Description").AsString = "Compacc System"
        lMain.FindField("PaymentMethod").AsString = "310-001"
        lMain.FindField("CHEQUENUMBER").AsString = "MBB 213245"
        lMain.FindField("DocAmt").AsFloat = 2019.57
        lMain.FindField("Cancelled").AsString = "F"
        lMain.Post

        'Step 6: Append Detail
        lDetail.Append
        lDetail.FindField("DTLKEY").value = -1
        lDetail.FindField("DOCKEY").value = -1
        lDetail.FindField("Code").AsString = "200-300"
        lDetail.FindField("DESCRIPTION").AsString = "Maybank - Asus A555LD-xx313H"
        lDetail.FindField("TAX").AsString = ""
        lDetail.FindField("TAXAMT").AsFloat = 0
        lDetail.FindField("TAXINCLUSIVE").AsFloat = 0
        lDetail.FindField("AMOUNT").AsFloat = 2019.57
        lDetail.Post

        'Step 7: Save Document
        BizObject.Save
        BizObject.Close
        MsgBox("Done", MsgBoxStyle.Information)
        FreeBiz(BizObject)
        Logout()
    End Sub

    Private Sub BtnXFInfo1_Click(sender As Object, e As EventArgs) Handles BtnXFInfo1.Click
        'This Example to get DO Number & Date that Tranfer to Invoice for given Invoice No.
        Dim lSQL, lxFer

        'Step 1: Create Com Server object
        CheckLogin()

        'Step 2: Get DocNo
        lbTime.Text = "Get DO Information..."
        lSQL = "SELECT DOCNO, DOCDATE FROM SL_DO "
        lSQL = lSQL + "WHERE DOCKEY = ( "
        lSQL = lSQL + "SELECT FIRST 1 B.FROMDOCKEY FROM SL_IV A "
        lSQL = lSQL + "INNER JOIN SL_IVDTL B ON(A.DOCKEY = B.DOCKEY) "
        lSQL = lSQL + "WHERE FROMDOCTYPE = 'DO' "
        lSQL = lSQL + "AND A.DOCNO = " + QuotedStr(edDocNo.Text)
        lSQL = lSQL + ")"

        lxFer = ComServer.DBManager.NewDataSet(lSQL)

        If lxFer.RecordCount > 0 Then
            edDesc.Text = lxFer.FindField("DocNo").AsString
        Else
            edDesc.Text = "No Record Found"
        End If
        FreeBiz(lxFer)
        Logout()
        lbTime.Text = ""
    End Sub

    Private Sub BtnXFInfo2_Click(sender As Object, e As EventArgs) Handles BtnXFInfo2.Click
        Dim lSQL, lxFer

        'Step 1: Create Com Server object
        CheckLogin()

        'Step 2: Get DocNo
        lbTime.Text = "Get Invoice Information..."
        lSQL = "SELECT A.DOCNO, A.DOCDATE FROM SL_IV A "
        lSQL = lSQL + "INNER JOIN SL_IVDTL B ON(A.DOCKEY = B.DOCKEY) "
        lSQL = lSQL + "WHERE FROMDOCTYPE = 'DO' "
        lSQL = lSQL + "AND FROMDOCKEY = (SELECT DOCKEY FROM SL_DO "
        lSQL = lSQL + "WHERE DOCNO = " + QuotedStr(edDocNo.Text)
        lSQL = lSQL + ")"

        lxFer = ComServer.DBManager.NewDataSet(lSQL)

        If lxFer.RecordCount > 0 Then
            edDesc.Text = lxFer.FindField("DocNo").AsString
        Else
            edDesc.Text = "No Record Found"
        End If
        FreeBiz(lxFer)
        Logout()
        lbTime.Text = ""
    End Sub

    Private Sub BtnARCT_Click(sender As Object, e As EventArgs) Handles BtnARCT.Click
        Dim lSQL, lDataSet, BizObject, lMain, lDetail, lDate, v(1)
        Dim lIVNO As String

        CheckLogin()

        lSQL = "SELECT Dockey FROM AR_CT "
        lSQL = lSQL + "WHERE DocNo='--CT Test--' "
        lDataSet = ComServer.DBManager.NewDataSet(lSQL)

        'Step 2: Find and Create the Biz Objects
        BizObject = ComServer.BizObjects.Find("AR_CT")

        'Step 3: Set Dataset
        lMain = BizObject.DataSets.Find("MainDataSet")   'lMain contains master data
        lDetail = BizObject.DataSets.Find("cdsKnockOff") 'lDetail contains detail data  

        'Step 4 : Posting
        lDate = CDate("January 23, 2020")
        If lDataSet.RecordCount > 0 Then
            BizObject.Params.Find("DocKey").Value = lDataSet.FindField("DocKey").AsString
            BizObject.Open()
            BizObject.Edit()
            lMain.Edit()
            lMain.FindField("Description").AsString = "Edited Description 123"

            'Step 5 Knock Off IV
            lIVNO = "IV-00021"
            v(0) = "IV"
            v(1) = lIVNO

            If (lDetail.Locate("DocType;DocNo", v, False, False)) Then
                lDetail.Edit
                lDetail.FindField("KOAmt").AsFloat = 52 'Partial Knock off
                lDetail.FindField("KnockOff").AsString = "T"
                lDetail.Post
            End If
        Else
            BizObject.[New]
            lMain.FindField("DOCKEY").Value = -1
            lMain.FindField("DocNo").AsString = "--CT Test--"
            lMain.FindField("CODE").AsString = "300-A0002" 'Customer Account
            lMain.FindField("DocDate").Value = lDate
            lMain.FindField("PostDate").Value = lDate
            lMain.FindField("Description").AsString = "Contra"
            lMain.FindField("DocAmt").AsFloat = 200.0
            lMain.FindField("Cancelled").AsString = "F"
            'Step 5: Knock Off IV
            lIVNO = "IV-00004"
            v(0) = "IV"
            v(1) = lIVNO

            If (lDetail.Locate("DocType;DocNo", v, False, False)) Then
                lDetail.Edit
                lDetail.FindField("KOAmt").AsFloat = 147.09 'Partial Knock off
                lDetail.FindField("KnockOff").AsString = "T"
                lDetail.Post
            End If
        End If
        'Step 6: Save Document
        BizObject.Save
        BizObject.Close
        MsgBox("Done", MsgBoxStyle.Information)
        FreeBiz(lDataSet)
        FreeBiz(BizObject)
    End Sub

    Private Sub BtnARIV_Click(sender As Object, e As EventArgs) Handles BtnARIV.Click
        Dim BizObject, lMain, lDetail,
            lFld_MDockey, lFld_DocNo,
            lFld_Code, lFld_DocDate, lFld_PostDate, lFld_Desc,
            lFld_DDockey, lFld_DtlKey, lFld_Seq, lFld_DDesc,
            lFld_Tax, lFld_TaxRate, lFld_TaxInc,
            lFld_Amt, lFld_TaxAmt, lDate

        CheckLogin(0)

        BizObject = ComServer.BizObjects.Find("AR_IV")
        lMain = BizObject.DataSets.Find("MainDataSet")  'lMain contains master data
        lDetail = BizObject.DataSets.Find("cdsDocDetail") 'lDetail contains detail data

        lFld_MDockey = lMain.FindField("DocKey")
        lFld_DocNo = lMain.FindField("DocNo")
        lFld_DocDate = lMain.FindField("DocDate")
        lFld_PostDate = lMain.FindField("PostDate")
        lFld_Code = lMain.FindField("Code")
        lFld_Desc = lMain.FindField("Description")

        lFld_DDockey = lDetail.FindField("DocKey")
        lFld_DtlKey = lDetail.FindField("DtlKey")
        lFld_Seq = lDetail.FindField("Seq")
        lFld_DDesc = lDetail.FindField("Description")
        lFld_Tax = lDetail.FindField("Tax")
        lFld_TaxRate = lDetail.FindField("TaxRate")
        lFld_TaxInc = lDetail.FindField("TaxInclusive")
        lFld_Amt = lDetail.FindField("Amount")
        lFld_TaxAmt = lDetail.FindField("TaxAmt")

        lDate = CDate("January 11, 2021")

        BizObject.[New]
        'Begin Append Master
        lFld_MDockey.value = -1
        lFld_DocNo.AsString = "--IV Test--"
        lFld_DocDate.value = lDate
        lFld_PostDate.value = lDate
        lFld_Code.AsString = "300-C0001" 'Customer Account
        lFld_Desc.AsString = "Invoice"

        'Step 5 Insert Data - Detail
        lDetail.Append
        lFld_DtlKey.value = -1
        lFld_DDockey.value = -1
        lFld_Seq.value = 1
        lFld_DDesc.AsString = "Sales Item A"
        lDetail.FindField("Account").AsString = "500-000"
        lFld_Tax.AsString = "SV"
        lFld_TaxRate.AsString = "6%"
        lFld_TaxInc.value = 0
        lFld_Amt.AsFloat = 200
        lFld_TaxAmt.AsFloat = 12
        lDetail.Post

        lDetail.Append()
        lFld_DtlKey.value = -1
        lFld_DDockey.value = -1
        lFld_Seq.value = 2
        lFld_DDesc.AsString = "Sales Item B"
        lDetail.FindField("Account").AsString = "500-3000"
        lFld_Tax.AsString = "SV"
        lFld_TaxRate.AsString = "6%"
        lFld_TaxInc.value = 0
        lFld_Amt.AsFloat = 30
        lFld_TaxAmt.AsFloat = 1.8
        lDetail.Post

        BizObject.Save
        BizObject.Close
        MsgBox("Done", MsgBoxStyle.Information)
        FreeBiz(BizObject)
        Logout()
    End Sub

    Private Sub BtnARPMBounce_Click(sender As Object, e As EventArgs) Handles BtnARPMBounce.Click
        Dim BizObject, lMain, lDocKey, lDate

        CheckLogin(0)
        'Step 2: Find and Create the Biz Objects
        BizObject = ComServer.BizObjects.Find("AR_PM")

        'Step 3: Set Dataset
        lMain = BizObject.DataSets.Find("MainDataSet") 'lMain contains master data

        'Step 4 : Find CN Number
        'lDocNo = "-- Test--"
        lDocKey = BizObject.FindKeyByRef("DocNo", edDocNo.Text.Trim)
        BizObject.Params.Find("DocKey").Value = lDocKey

        If Not IsDBNull(lDocKey) Then
            lDate = CDate("January 11, 2021")
            BizObject.Open
            BizObject.Edit
            lMain.Edit
            lMain.FindField("BOUNCEDDATE").value = lDate
            'Step 6: Save Document
            BizObject.Save
            BizObject.Close
            MsgBox("Done", MsgBoxStyle.Information)
        End If
        FreeBiz(BizObject)
    End Sub

    Private Sub BtnLedgerRO_Click(sender As Object, e As EventArgs) Handles BtnLedgerRO.Click
        Dim RptObject, lDateFrom, lDateTo, lDataSet

        'Step 1: Create Com Server object
        CheckLogin()
        'Step 2: Find and Create the Report Objects
        RptObject = ComServer.RptObjects.Find("GL.Ledger.RO")
        'Step 3: Spool parameters
        lDateFrom = CDate("July 01, 2020")
        lDateTo = CDate("July 31, 2020")

        RptObject.Params.Find("DateFrom").Value = lDateFrom
        RptObject.Params.Find("UseDescription2").Value = False
        RptObject.Params.Find("ShowLocal").Value = True
        RptObject.Params.Find("ShowForeign").Value = False
        RptObject.Params.Find("SelectDate").Value = True
        RptObject.Params.Find("DateTo").Value = lDateTo
        'RptObject.Params.Find("ProjectData").Value = //Not use if AllProject Is true
        RptObject.Params.Find("MergeGLCode").Value = True
        RptObject.Params.Find("AllProject").Value = True
        RptObject.Params.Find("AllAccount").Value = False
        RptObject.Params.Find("AccountType").Value = "G" 'G = General Ledger, P = Purchase Ledger, S = Sales Ledger
        RptObject.Params.Find("AccountData").Value = "310-001" + Environment.NewLine + "500-0000"
        'RptObject.Params.Find("ControlAccountData").Value = //Not use if AllControlAccount Is true
        RptObject.Params.Find("AllControlAccount").Value = True
        RptObject.Params.Find("AllAgent").Value = True
        RptObject.Params.Find("AllArea").Value = True
        RptObject.Params.Find("GroupBy").Value = "Code"
        RptObject.Params.Find("IncludeZeroClosingBalance").Value = True
        RptObject.Params.Find("IncludeZeroTransaction").Value = True
        ' RptObject.Params.Find("AgentData").Value = 'Not use if AllAgent Is true
        'RptObject.Params.Find("TaxData").Value = 'Not use if AllTax Is true
        RptObject.Params.Find("AllTax").Value = True
        'RptObject.Params.Find("AreaData=").Value = 'Not use if AllArea Is true
        RptObject.Params.Find("ExcludeProjectWhenMerge").Value = False
        RptObject.Params.Find("ByTaxDate").Value = False
        RptObject.Params.Find("GroupControlAccount").Value = False
        RptObject.Params.Find("SortBy").Value = "Code;AccDesc;PostDate"

        'Step 4 Perform Report calculation 
        RptObject.CalculateReport()

        lDataSet = RptObject.DataSets.Find("cdsMain")
        'Step 5 : Convert to Dataset
        PrepareData(lDataSet, "Master")

        ' Step 6  Bind the Master to the dataset.
        MasterBS.DataSource = Tbl
        MasterBS.DataMember = "Master"

        ' Step 7  Set Grid Info
        DataGVM.DataSource = MasterBS
        MessageBox.Show("Done", "Status", MessageBoxButtons.OK, MessageBoxIcon.Information)

        ' Step 8  Logout after done 
        FreeBiz(lDataSet)
        MsgBox("Done", MsgBoxStyle.Information)
        RptObject = Nothing
    End Sub

    Private Sub Button1_Click(sender As Object, e As EventArgs) Handles Button1.Click
        Dim BizObject, lMain, lDetail, lKO,
            lFld_MDockey, lFld_DocNo,
            lFld_Code, lFld_DocDate, lFld_PostDate, lFld_Desc,
            lFld_DDockey, lFld_DtlKey, lFld_Seq, lFld_DDesc,
            lFld_Tax, lFld_TaxRate, lFld_TaxInc,
            lFld_Amt, lFld_TaxAmt, lDate, v(1)
        Dim lIVNO As String

        CheckLogin(0)

        BizObject = ComServer.BizObjects.Find("AR_CN")
        lMain = BizObject.DataSets.Find("MainDataSet")  'lMain contains master data
        lDetail = BizObject.DataSets.Find("cdsDocDetail") 'lDetail contains detail data
        lKO = BizObject.DataSets.Find("cdsKnockOff")

        lFld_MDockey = lMain.FindField("DocKey")
        lFld_DocNo = lMain.FindField("DocNo")
        lFld_DocDate = lMain.FindField("DocDate")
        lFld_PostDate = lMain.FindField("PostDate")
        lFld_Code = lMain.FindField("Code")
        lFld_Desc = lMain.FindField("Description")

        lFld_DDockey = lDetail.FindField("DocKey")
        lFld_DtlKey = lDetail.FindField("DtlKey")
        lFld_Seq = lDetail.FindField("Seq")
        lFld_DDesc = lDetail.FindField("Description")
        lFld_Tax = lDetail.FindField("Tax")
        lFld_TaxRate = lDetail.FindField("TaxRate")
        lFld_TaxInc = lDetail.FindField("TaxInclusive")
        lFld_Amt = lDetail.FindField("Amount")
        lFld_TaxAmt = lDetail.FindField("TaxAmt")

        lDate = CDate("January 11, 2021")

        BizObject.[New]
        'Begin Append Master
        lFld_MDockey.value = -1
        lFld_DocNo.AsString = "--CN Test--"
        lFld_DocDate.value = lDate
        lFld_PostDate.value = lDate
        lFld_Code.AsString = "300-C0001" 'Customer Account
        lFld_Desc.AsString = "Credit Note"

        'Step 5 Insert Data - Detail
        lDetail.Append
        lFld_DtlKey.value = -1
        lFld_DDockey.value = -1
        lFld_Seq.value = 1
        lFld_DDesc.AsString = "Sales Item A"
        lDetail.FindField("Account").AsString = "500-000"
        lFld_Tax.AsString = "SV"
        lFld_TaxRate.AsString = "6%"
        lFld_TaxInc.value = 0
        lFld_Amt.AsFloat = 200
        lFld_TaxAmt.AsFloat = 12
        lDetail.Post

        lDetail.Append()
        lFld_DtlKey.value = -1
        lFld_DDockey.value = -1
        lFld_Seq.value = 2
        lFld_DDesc.AsString = "Sales Item B"
        lDetail.FindField("Account").AsString = "500-3000"
        lFld_Tax.AsString = "SV"
        lFld_TaxRate.AsString = "6%"
        lFld_TaxInc.value = 0
        lFld_Amt.AsFloat = 10
        lFld_TaxAmt.AsFloat = 0.6
        lDetail.Post

        'Step 6: Knock Off IV
        lIVNO = "--IV Test--"
        v(0) = "IV"
        v(1) = lIVNO

        If (lKO.Locate("DocType;DocNo", v, False, False)) Then
            lKO.Edit
            lKO.FindField("KOAmt").AsFloat = 147.09 'Partial Knock off
            lKO.FindField("KnockOff").AsString = "T"
            lKO.Post
        End If

        BizObject.Save
        BizObject.Close
        MsgBox("Done", MsgBoxStyle.Information)
        FreeBiz(BizObject)
        Logout()
    End Sub

    Private Sub BtnAddSTLoc_Click(sender As Object, e As EventArgs) Handles BtnAddSTLoc.Click
        Dim BizObject, lMain, lDocKey As Object
        Dim strCode, strDesc, v As String

        'Step 1: Create Com Server object
        CheckLogin()
        'Step 2: Find and Create the Biz Objects
        BizObject = ComServer.BizObjects.Find("ST_Location")

        'Step 3: Set Dataset
        lMain = BizObject.DataSets.Find("MainDataSet")

        strCode = edCode.Text.Trim
        strDesc = edDesc.Text.Trim

        'Step 3: Insert or Update
        lDocKey = BizObject.FindKeyByRef("CODE", strCode)
        If IsDBNull(lDocKey) Then
            BizObject.[New]
            lMain.FindField("CODE").value = strCode
            lMain.FindField("Description").value = strDesc
            lMain.FindField("Address1").AsString = "Address1"
            lMain.FindField("Address2").AsString = "Address2"
            lMain.FindField("Address3").AsString = "Address3"
            lMain.FindField("Address4").AsString = "Address4"
            lMain.FindField("Attention").AsString = "Attention"
            lMain.FindField("Phone1").AsString = "Phone1"
            lMain.FindField("Fax1").AsString = "Fax1"
            lMain.FindField("Email").AsString = "EmailAddress"
        Else 'Edit Data if found
            BizObject.Params.Find("CODE").Value = lDocKey
            BizObject.Open
            BizObject.Edit
            lMain.FindField("Description").value = strDesc
            lMain.FindField("Address1").AsString = "Address1-Changed"
            lMain.FindField("Address2").AsString = "Address2-Changed"
            lMain.FindField("Address3").AsString = "Address3-Changed"
            lMain.FindField("Address4").AsString = "Address4-Changed"
            lMain.FindField("Attention").AsString = "Attention-Changed"
            lMain.FindField("Phone1").AsString = "Phone1-Changed"
            lMain.FindField("Fax1").AsString = "Fax1-Changed"
            lMain.FindField("Email").AsString = "EmailAddress-Changed"
        End If
        'Step 4: Save & Close
        BizObject.Save
        BizObject.close
        MsgBox("Done", MsgBoxStyle.Information)
        'Step 5 : Logout after done         
        FreeBiz(BizObject)
        Logout()
    End Sub

    Private Sub Button2_Click(sender As Object, e As EventArgs) Handles Button2.Click
        Dim lSQL, lDataSet, BizObject, lMain, lDetail, lDate

        CheckLogin(0)

        lSQL = "SELECT Dockey FROM SL_IV "
        lSQL = lSQL & "WHERE DocNo='--CS Test--' "
        lSQL = lSQL & " AND Code='300-C0001' "
        lDataSet = ComServer.DBManager.NewDataSet(lSQL)

        lbTime.Text = "Posting Cash Sales..."
        'Step 2: Find and Create the Biz Objects
        BizObject = ComServer.BizObjects.Find("SL_IV")

        'Step 3: Set Dataset
        lMain = BizObject.DataSets.Find("MainDataSet")  'lMain contains master data
        lDetail = BizObject.DataSets.Find("cdsDocDetail") 'lDetail contains detail data

        'Begin Looping yr data
        If lDataSet.RecordCount > 0 Then
            lDataSet.First
            BizObject.Params.Find("DocKey").Value = lDataSet.FindField("DocKey").AsString

            BizObject.Open
            BizObject.Edit
            lMain.Edit
            lMain.FindField("Description").AsString = "Edited Description 123"

            'Step 6: Delete all Detail
            While lDetail.RecordCount <> 0
                lDetail.First
                lDetail.Delete
            End While

            'Step 7: Append Detail
            lDetail.Append
            lDetail.FindField("DtlKey").value = -1
            lDetail.FindField("Account").value = "500-0000"
            lDetail.FindField("Description").value = "Item A"
            lDetail.FindField("Description3").AsString = FormatAsRTF("Sales Item desc 3 B 😁")
            lDetail.FindField("Tax").value = ""
            lDetail.FindField("TaxInclusive").value = 0
            lDetail.FindField("Amount").value = 90
            lDetail.FindField("TaxAmt").value = 0
            lDetail.Post

            'Step 8: Save Document
            BizObject.Save
            BizObject.Close

            MsgBox("Done", MsgBoxStyle.Information)
        Else
            MsgBox("Record Not Found", MsgBoxStyle.Exclamation)
        End If
        'Step 9 : Logout after done  
        FreeBiz(BizObject)
        FreeBiz(lDataSet)
        'Logout()
    End Sub

    Private Sub btnSTBatch_Click(sender As Object, e As EventArgs) Handles btnSTBatch.Click
        Dim BizObject, lMain, lDtl, lDup As Object
        Dim strCode, strDesc, lSQL, lCode As String

        'Create Com Server object
        CheckLogin()

        strCode = edCode.Text.Trim
        strDesc = edDesc.Text.Trim

        lbTime.Text = "Check Duplicate Status..."
        lSQL = "SELECT Code FROM ST_BATCH "
        lSQL = lSQL & "WHERE Code=" & QuotedStr(strCode)
        lDup = ComServer.DBManager.NewDataSet(lSQL)

        If lDup.RecordCount = 0 Then
            lCode = ""
        Else
            lCode = lDup.FindField("Code").AsString
        End If

        'Find and Create the Biz Objects
        BizObject = ComServer.BizObjects.Find("ST.BATCH.OPF")

        'Set Dataset
        lMain = BizObject.DataSets.Find("Main")
        lDtl = BizObject.DataSets.Find("BatchItem")

        'Insert or Update

        If lCode = "" Then
            BizObject.[New]
            lMain.FindField("CODE").AsString = strCode
            lMain.FindField("Description").AsString = strDesc
            lMain.FindField("OISACTIVE").Value = 1

            'Insert Data - Detail
            'For 1st ItemCode
            lDtl.Append
            lDtl.FindField("ItemCode").AsString = "BOM"
            lDtl.Post

            'For 2nd ItemCode
            lDtl.Append
            lDtl.FindField("ItemCode").AsString = "E-BAT"
            lDtl.Post
        Else 'Edit Data if found
            BizObject.Params.Find("CODE").Value = strCode
            BizObject.Open
            BizObject.Edit
            lMain.FindField("Description").AsString = strDesc
            lMain.FindField("OISACTIVE").Value = 0

            'Delete all Detail
            While lDtl.RecordCount <> 0
                lDtl.First
                lDtl.Delete
            End While

            lDtl.Append
            lDtl.FindField("ItemCode").AsString = "ANT"
            lDtl.Post
        End If
        'Save & Close
        BizObject.Save
        BizObject.close
        MsgBox("Done", MsgBoxStyle.Information)
        'Logout after done         
        FreeBiz(BizObject)
        Logout()
    End Sub

    Private Sub btnReconnect_Click(sender As Object, e As EventArgs) Handles btnReconnect.Click
        Dim lSQL, lDataSet

        'Create Com Server object
        CheckLogin()
        Thread.Sleep(5000)
        'Get Option
        lSQL = "SELECT RNAME, RVALUE FROM SY_REGISTRY "
        lSQL = lSQL & "WHERE RNAME IN ('CustomerOneCentDiffRounding', "
        lSQL = lSQL & "'CustomerRTN5CentsCS', 'CustomerRTN5CentsIV') "
        Try
            lDataSet = ComServer.DBManager.NewDataSet(lSQL)

            PrepareData(lDataSet, "Master")

            'Bind the Master to the dataset.
            MasterBS.DataSource = Tbl
            MasterBS.DataMember = "Master"

            'Set Datasoure to Grid
            DataGVM.DataSource = MasterBS
            FreeBiz(lDataSet)
        Catch ex As Exception
            If (System.Text.RegularExpressions.Regex.IsMatch(ex.Message, "^Error writing data to the connection\\.")) Then
                'Get Option
                lSQL = "SELECT RNAME, RVALUE FROM SY_REGISTRY "
                lSQL = lSQL & "WHERE RNAME IN ('CustomerOneCentDiffRounding', "
                lSQL = lSQL & "''CustomerRTN5CentsIV') "

                ComServer.Reconnect()
                lDataSet = ComServer.DBManager.NewDataSet(lSQL)

                PrepareData(lDataSet, "Master")

                'Bind the Master to the dataset.
                MasterBS.DataSource = Tbl
                MasterBS.DataMember = "Master"

                'Set Datasoure to Grid
                DataGVM.DataSource = MasterBS
                FreeBiz(lDataSet)
            End If
        End Try
        lbTime.Text = System.DateTime.Now.ToString("dd MMM yyyy HH:mm:ss")
        'Logout after done 
        Logout()
    End Sub

    Private Sub BtnARState_Click(sender As Object, e As EventArgs) Handles BtnARState.Click
        ' C1 - Current Month
        ' C2 - 1 Month
        ' C3 - 2 Months 
        ' C4 - 3 Months
        ' C5 - 4 Months 
        ' C6 - 5 Months & above
        Const Quote = """"
        Dim RptObject, lDataSet1, lDataSet2, lDateTo, lDateFrom, lAgeData
        Dim tblC1, tblC2 As DataColumn
        Dim drt As DataRelation

        'Step 1: Create Com Server object
        CheckLogin()
        'Step 2: Find and Create the Report Objects
        RptObject = ComServer.RptObjects.Find("Customer.Statement.RO")
        'Step 3: Spool parameters
        lAgeData = "<?xml version=" & Quote & "1.0" & Quote & " standalone=" & Quote & "yes" & Quote & "?>  <DATAPACKET Version=" & Quote & "2.0" & Quote & "><METADATA><FIELDS>" &
                       "<FIELD attrname=" & Quote & "ColumnNo" & Quote & " fieldtype=" & Quote & "i4" & Quote & " required=" & Quote & "true" & Quote & "/><FIELD attrname=" & Quote & "ColumnType" & Quote & " fieldtype=" & Quote & "string" & Quote & " WIDTH=" & Quote & "1" & Quote & "/>" &
                       "<FIELD attrname=" & Quote & "Param1" & Quote & " fieldtype=" & Quote & "i4" & Quote & " required=" & Quote & "true" & Quote & "/><FIELD attrname=" & Quote & "Param2" & Quote & " fieldtype=" & Quote & "i4" & Quote & " required=" & Quote & "true" & Quote & "/>" &
                       "<FIELD attrname=" & Quote & "IsLocal" & Quote & " fieldtype=" & Quote & "boolean" & Quote & "/><FIELD attrname=" & Quote & "HeaderScript" & Quote & " fieldtype=" & Quote & "bin.hex" & Quote & " SUBTYPE=" & Quote & "Text" & Quote & " WIDTH=" & Quote & "1" & Quote & "/>" &
                       "</FIELDS><PARAMS/></METADATA><ROWDATA><ROW ColumnNo=" & Quote & "0" & Quote & " ColumnType=" & Quote & "" & Quote & " Param1=" & Quote & "0" & Quote & " Param2=" & Quote & "0" & Quote & " IsLocal=" & Quote & "FALSE" & Quote & "/>" &
                       "<ROW ColumnNo=" & Quote & "1" & Quote & " ColumnType=" & Quote & "A" & Quote & " Param1=" & Quote & "0" & Quote & " Param2=" & Quote & "0" & Quote & " IsLocal=" & Quote & "FALSE" & Quote & " HeaderScript=" & Quote & "ObjectPascal&#013;begin&#013;Value:= &apos;Current Mth&apos;&#013;end;" & Quote & "/>" &
                       "<ROW ColumnNo=" & Quote & "2" & Quote & " ColumnType=" & Quote & "A" & Quote & " Param1=" & Quote & "-1" & Quote & " Param2=" & Quote & "-1" & Quote & " IsLocal=" & Quote & "FALSE" & Quote & " HeaderScript=" & Quote & "ObjectPascal&#013;begin&#013;Value:= &apos;1 Months&apos;&#013;end;" & Quote & "/>" &
                       "<ROW ColumnNo=" & Quote & "3" & Quote & " ColumnType=" & Quote & "A" & Quote & " Param1=" & Quote & "-2" & Quote & " Param2=" & Quote & "-2" & Quote & " IsLocal=" & Quote & "FALSE" & Quote & " HeaderScript=" & Quote & "ObjectPascal&#013;begin&#013;Value:= &apos;2 Months&apos;&#013;end;" & Quote & "/>" &
                       "<ROW ColumnNo=" & Quote & "4" & Quote & " ColumnType=" & Quote & "A" & Quote & " Param1=" & Quote & "-3" & Quote & " Param2=" & Quote & "-3" & Quote & " IsLocal=" & Quote & "FALSE" & Quote & " HeaderScript=" & Quote & "ObjectPascal&#013;begin&#013;Value:= &apos;3 Months&apos;&#013;end;" & Quote & "/>" &
                       "<ROW ColumnNo=" & Quote & "5" & Quote & " ColumnType=" & Quote & "A" & Quote & " Param1=" & Quote & "-4" & Quote & " Param2=" & Quote & "-4" & Quote & " IsLocal=" & Quote & "FALSE" & Quote & " HeaderScript=" & Quote & "ObjectPascal&#013;begin&#013;Value:= &apos;4 Months&apos;&#013;end;" & Quote & "/>" &
                       "<ROW ColumnNo=" & Quote & "6" & Quote & " ColumnType=" & Quote & "B" & Quote & " Param1=" & Quote & "-999999" & Quote & " Param2=" & Quote & "-5" & Quote & " IsLocal=" & Quote & "FALSE" & Quote & " HeaderScript=" & Quote & "ObjectPascal&#013;begin&#013;Value:= &apos;5 Month &amp; above&apos;&#013;end;" & Quote & "/>" &
                       "</ROWDATA></DATAPACKET>"

        ' RptObject.Params.Find("AgentData").Value            =  'Not use if AllAgent is True
        RptObject.Params.Find("AgingData").Value = lAgeData 'Fixed
        RptObject.Params.Find("AgingOn").Value = "I" ' Fixed
        RptObject.Params.Find("AllAgent").Value = True
        RptObject.Params.Find("AllArea").Value = True
        RptObject.Params.Find("AllCompany").Value = True
        RptObject.Params.Find("AllCompanyCategory").Value = True
        RptObject.Params.Find("AllControlAccount").Value = True
        RptObject.Params.Find("AllCurrency").Value = True
        RptObject.Params.Find("AllDocProject").Value = True
        'RptObject.Params.Find("AreaData").Value             =  'Not use if AllArea is True
        'RptObject.Params.Find("CompanyCategoryData").Value  =  'Not use if AllCompanyCategory is True
        'RptObject.Params.Find("CompanyData").Value = "300-A0001" + Environment.NewLine + "300-C0001" //Filter by Customer Code 300-A0001 & 300-C0001
        'RptObject.Params.Find("ControlAccountData").Value   =  'Not use if AllControlAccount is True
        'RptObject.Params.Find("CurrencyData").Value         =  'Not use if AllCurrency is True
        'RptObject.Params.Find("DocProjectData").Value       =  'Not use if AllDocProject is True

        lDateFrom = DateTime.Parse("December 1, 2021")
        lDateTo = DateTime.Parse("December 29, 2021")
        RptObject.Params.Find("DateFrom").Value = lDateFrom
        RptObject.Params.Find("DateTo").Value = lDateTo


        RptObject.Params.Find("IncludeZeroBalance").Value = False
        RptObject.Params.Find("SelectDate").Value = True
        RptObject.Params.Find("SortBy").Value = "CompanyCategory;Code;CompanyName;Agent;Area;CurrencyCode;ControlAccount"
        RptObject.Params.Find("StatementDate").Value = lDateTo
        RptObject.Params.Find("StatementType").Value = "O" 'O = Open Item, B = B/F

        'Step 4 Perform Report calculation 
        RptObject.CalculateReport()
        lDataSet1 = RptObject.DataSets.Find("cdsMain")
        lDataSet2 = RptObject.DataSets.Find("cdsAging")
        'MessageBox.Show("Count - Main " + lDataSet1.RecordCount, "Count", MessageBoxButtons.OK, MessageBoxIcon.Information)
        'MessageBox.Show("Count - Document " + lDataSet2.RecordCount, "Count", MessageBoxButtons.OK, MessageBoxIcon.Information)

        'Step 5 : Convert to Dataset
        ClearTables()

        PrepareData(lDataSet1, "Master")
        PrepareData(lDataSet2, "Detail")

        'Step 6 : Get Relation column
        tblC1 = Tbl.Tables("Master").Columns("Code")
        tblC2 = Tbl.Tables("Detail").Columns("Code")
        drt = New DataRelation("relation", tblC1, tblC2)


        'Step 7 : Set Grid Info
        SetGridInfo(drt)

        MsgBox("Done", MsgBoxStyle.Information)

        'Step 8 : Logout after done 
        Logout()
        RptObject = Nothing
    End Sub

    Private Sub BtnARPM_Click(sender As Object, e As EventArgs) Handles BtnARPM.Click
        Dim lSQL, lDataSet, BizObject, lMain, lDetail, V(1), lDate
        Dim lIVNO As String

        CheckLogin(0)

        lSQL = "SELECT Dockey FROM AR_PM "
        lSQL = lSQL + "WHERE DocNo='--PM Test--' "
        lDataSet = ComServer.DBManager.NewDataSet(lSQL)

        'Step 2 Find And Create the Biz Objects
        BizObject = ComServer.BizObjects.Find("AR_PM")

        'Step 3 Set Dataset
        lMain = BizObject.DataSets.Find("MainDataSet")    'lMain contains master data
        lDetail = BizObject.DataSets.Find("cdsKnockOff")  'lDetail contains detail data  

        'Step 4  Posting
        lDate = CDate("January 23, 2022")
        If (lDataSet.RecordCount > 0) Then 'Found Then Do Edit
            BizObject.Params.Find("DocKey").Value = lDataSet.FindField("DocKey").AsString
            BizObject.Open()
            BizObject.Edit()
            lMain.Edit()
            lMain.FindField("Description").AsString = "Edited Description 123"

            'Step 5 Knock Off IV
            lIVNO = "IV-00085"
            V(0) = "IV"
            V(1) = lIVNO

            If (lDetail.Locate("DocType;DocNo", V, False, False)) Then
                lDetail.Edit()
                lDetail.FindField("KOAmt").AsFloat = 52 'Partial Knock off 
                lDetail.FindField("KnockOff").AsString = "T"
                lDetail.Post()
            End If
        Else
            BizObject.[New]
            lMain.FindField("DOCKEY").Value = -1
            lMain.FindField("DocNo").AsString = "--PM Test--"
            lMain.FindField("CODE").AsString = "300-C0001" 'Customer Account
            lMain.FindField("DocDate").Value = lDate
            lMain.FindField("PostDate").Value = lDate
            lMain.FindField("Description").AsString = "Payment for A/c"
            lMain.FindField("PaymentMethod").AsString = "320-000" 'Bank Or Cash Account
            lMain.FindField("ChequeNumber").AsString = ""
            lMain.FindField("BankCharge").AsFloat = 0
            lMain.FindField("DocAmt").AsFloat = 200.0
            lMain.FindField("Cancelled").AsString = "F"
            lMain.Post()

            'Step 5 Knock Off IV
            lIVNO = "IV-00083"
            V(0) = "IV"
            V(1) = lIVNO

            If (lDetail.Locate("DocType;DocNo", V, False, False)) Then
                lDetail.Edit()
                lDetail.FindField("KOAmt").AsFloat = 147.09 '/Partial Knock off
                lDetail.FindField("KnockOff").AsString = "T"
                lDetail.Post()
            End If
        End If

        'Step 6 Save Document
        BizObject.Save()
        BizObject.Close()
        'Step 10 : Logout after done 
        MessageBox.Show("Done", "Posting Status", MessageBoxButtons.OK, MessageBoxIcon.Information)
        FreeBiz(lDataSet)
        FreeBiz(BizObject)
        Logout()
    End Sub

    Private Sub btnLogInOut_Click(sender As Object, e As EventArgs) Handles btnLogInOut.Click
        Dim I As Integer
        Dim lSQL, lDataSet

        For I = 1 To edRecord.Value
            If IsOdd(I) Then
                CheckLogin(0)
            Else
                CheckLogin(1)
            End If

            lSQL = "SELECT DESCRIPTION FROM AGENT "
            lSQL = lSQL & "ORDER BY RAND() "
            lDataSet = ComServer.DBManager.NewDataSet(lSQL)
            edDesc.Text = lDataSet.FindField("Description").AsString
            lbTime.Text = "Record No : " & I

            FreeBiz(lDataSet)
            ComServer.Logout
            FreeBiz(ComServer)
            Thread.Sleep(5000) 'Sleep for 5 seconds.
        Next
    End Sub

    Private Sub BtnValidGLAcc_Click(sender As Object, e As EventArgs) Handles BtnValidGLAcc.Click
        'This Example to get IV Number & Date that Tranfer From DO for given DO No.
        Dim lSQL, lDataSet
        Dim B As Boolean

        'Create Com Server object
        CheckLogin()

        'Query Data
        lSQL = "SELECT A.Dockey, A.Parent, A.Code, A.Description, A.SpecialAccType FROM GL_ACC A "
        lSQL = lSQL & "LEFT OUTER JOIN GL_ACC B ON (A.Dockey=B.Parent) "
        lSQL = lSQL & "WHERE A.Parent<>-1 "
        lSQL = lSQL & "AND B.Dockey IS NULL "
        lSQL = lSQL & "AND A.SpecialAccType NOT IN('DC', 'CC') "
        lSQL = lSQL & "AND A.CODE= " & QuotedStr(edCode.Text)
        lDataSet = ComServer.DBManager.NewDataSet(lSQL)

        B = lDataSet.RecordCount > 0

        edDocNo.Text = If(B, "Is Valid Account Code", edCode.Text & " is Not Valid Account Code")

        'Logout after done 
        FreeBiz(lDataSet)
        Logout()
    End Sub

End Class
